/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : TZconvertApp.sql
 *
 * Description:   convert timezone during appAware mount
 *
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set verify off
set timing off
set echo off

SELECT to_char(FROM_TZ(CAST(TO_DATE('&1',
     'YYYYMMDDHH24MISS') AS TIMESTAMP), 'Etc/GMT')
     AT TIME ZONE '&2','YYYYMMDDHH24MISS')
FROM DUAL;

exit

