#!/usr/bin/perl

use MIME::Base64;
use Sys::Hostname;
use Storable;
use Socket;
use File::Basename;
use File::Find;
use Cwd;
use Data::Dumper;
use URI::Escape;

my @session;
my %appdetails;
my $appdetails;
my @sourcelist;
my $sourcelist;
my @hostdetails;
my $hostdetails;

my %arghash = @ARGV;
$| = 1;
my $hostname;
my $appname;
my $bkptype;
my $count=0;
my $pwd;
my $detfile;
my $AGMips;
my $userfile;
my @sesdir;
my $AGMip;
my $sesfile;
my $retuser;
#my $appid;
my @app;
my $app;

die "Usage:actAGMDBM\n       --type \n            <listAppliance> \n            <backup> \n            <agmconfig> \n            <listImageDetails> \n            <mount> \n            <clone> \n            <cleanup> \n            <runwf> \n" if (!exists $arghash{'--type'} );
die "Usage:actAGMDBM\n       --type \n            <listAppliance> \n            <backup> \n            <agmconfig> \n            <listImageDetails> \n            <mount> \n            <clone> \n            <cleanup> \n            <runwf> \n" if ( (exists $arghash{'--help'}) && (!exists $arghash{'--type'}) );

if ( $arghash{'--type'} eq "agmconfig" ) {
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( !exists $arghash{'--username'} );
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( !exists $arghash{'--password'} );
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( !exists $arghash{'--AGM'} );
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "agmconfig") );
    my $username=$arghash{'--username'};
    my $password_en=MIME::Base64::encode($arghash{'--password'});
    my $AGMip=$arghash{'--AGM'};

    my %userhash = (username => $username, password => $password_en, AGMip => $AGMip);
    $pwd = cwd();
    #print "dir is " . $pwd;
    $detfile=$pwd . "/" . $AGMip . "_details";
    #print "file is " . $detfile;
    store \%userhash, $detfile;
    print "user details are stored successfully \n";
} #end of if - agmconfig

if ($arghash{'--type'} eq "listAppliance" ) {
   die "Usage:actAGMDBM --type listAppliance \n --appname <application name> \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "listAppliance") );
    die "Usage:actAGMDBM --type listAppliance \n --appname <application name> \n --AGM <AGM name|ip> \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "listAppliance") );

$appname=$arghash{'--appname'};

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actAGMDBM --type listAppliance \n --appname <application name> \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "listAppliance") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

listAppliance();
} #end of if - listAppliance

if ($arghash{'--type'} eq "listImageDetails" ) {
   die "Usage:actAGMDBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "listImageDetails") );
   die "Usage:actAGMDBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "listImageDetails") );

$appname=$arghash{'--appname'};
$hostname=$arghash{'--hostname'};

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n  Usage:actAGMDBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "listImageDetails") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }
listImageDetails();
} #end of if - listImageDetails

#sub wanted {
#    if(/_details$/) {
#        $userfile=$_;
#        $count++;
#    }

# }

$userfile;
sub wanted {
    #my $file_name = $_;
     $file_list = $AGMip . "_details";
    if ( ( -f $file_list ) ) {
        $userfile=$file_list;
     $count++;
     last;
    }
   # $count++;
}

if ($arghash{'--type'} eq "backup" ) {
   die "Usage:actAGMDBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n  [--backuplabel <backup label name>] \n [--jobpriority <low|medium|high>] \n --AGM <AGM name|ip> \n [--wait <yes|no>] \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "backup") );
    die "Usage:actAGMDBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--backuplabel <backup label name>] \n [--jobpriority <low|medium|high>] \n --AGM <AGM name|ip> \n [--wait <yes|no>] \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "backup") );

$appname=$arghash{'--appname'};

if ( !exists $arghash{'--hostname'} ) {
        $hostname=hostname;
        $hostname =~ s/(\w+)\..*/\1/;
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $hostname=$arghash{'--hostname'};
    }
    if ( !exists $arghash{'--backuptype'} ) {
        $bkptype="db";
    }
    elsif ( exists $arghash{'--backuptype'} ) {
        $bkptype=$arghash{'--backuptype'};
    }

    if ( exists $arghash{'--jobpriority'} ) {
        $jobpriority=$arghash{'--jobpriority'};
    }

    if ( exists $arghash{'--backuplabel'} ) {
        $backuplabel=$arghash{'--backuplabel'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

        if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actAGMDBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--backuplabel <backup label name>] \n [--jobpriority <low|medium|high>] \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "backup") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

backup();
} #end of if - backup

if ($arghash{'--type'} eq "mount" ) {
   die "Usage:actAGMDBM --type mount \n --dbname <database name> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--targetHost <Target Host name>] \n [--ASMdiskgroup <ASM diskgroup name>] \n [--RACNodeList <RAC node list>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "mount") );
    die "Usage:actAGMDBM --type mount \n --dbname <database name> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--targetHost <Target Host name>] \n [--ASMdiskgroup <ASM diskgroup name>] \n [--RACNodeList <RAC node list>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--dbname'} ) && ($arghash{'--type'} eq "mount") );
    $appname=$arghash{'--dbname'};
    $sourceHost=hostname;
    $sourceHost =~ s/(\w+)\..*/\1/;
    $image="";
    $targetHost=$sourceHost;

    if ( exists $arghash{'--sourceHost'} ) {
        $hostname=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
    if ( exists $arghash{'--targetHost'} ) {
        $targetHost=$arghash{'--targetHost'};
    }
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( exists $arghash{'--ASMdiskgroup'} ) {
        $asmDG=$arghash{'--ASMdiskgroup'};
    }
    if ( exists $arghash{'--RACNodeList'} ) {
        $RACNodeList=$arghash{'--RACNodeList'};
        $RACNodeList=~s/\:/%3A/g;
        printf $RACNodeList . "\n";
    }

    if ( exists $arghash{'--mountpoint'} ) {
        $mountpoint=$arghash{'--mountpoint'};
    }

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actAGMDBM --type mount \n --dbname <database name> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--targetHost <Target Host name>] \n [--ASMdiskgroup <ASM diskgroup name>] \n [--RACNodeList <RAC node list>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "mount") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

 mount();

} #end of if - mount


if ($arghash{'--type'} eq "clone" ) {
  die "Usage: perl actAGMDBM.pl --type clone \n [--optype <newclone>]\n" if ( ( (exists $arghash{'--help'} ) || (!exists $arghash{'--help'} ) ) && ($arghash{'--type'} eq "clone") && (!exists $arghash{'--optype'} ) );
  die "Usage: perl actAGMDBM.pl --type clone \n [--optype <newclone>] \n --dbname <source database name> \n [--remoteApp <no|yes>] \n --TargetDBname <app-aware mount database name> \n --OSusername <OS oracle owner> \n --TargetOracleHome <Target Oracle Home> \n [--listenerpath <Target Oracle Listener path>] \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--SharedPoolSize <shared pool size in MB>] \n [--DBcacheSize <DB cache size in MB>] \n [--DBrecoveryFileDestSize <DB Recovery file dest size in MB>] \n [--Processes <Number of Processes>] \n [--OpenCursors <Max Number of Cursors>] \n [--DiagnosticDestination <Diagnostic Destination>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--redosize <redo size in MB>] \n [--recovery <yes|no>] \n [--envvar <variable1:variable2>] \n [--backuplabel <backup label ID>] \n [--standalone <yes|no>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n [--DoNotUpdateTNSname <flag to update TNSentry yes|no>] \n [--DoNotchangeDBid <flag to change DBID yes|no>] \n [--template <child db protect template name>] \n [--profile <child db protect profile name>] \n --AGM <AGM ip|name> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--TargetDBname'} ) || ( !exists $arghash{'--TargetOracleHome'} ) || ( !exists $arghash{'--dbname'} ))  && ($arghash{'--type'} eq "clone") &&  ($arghash{'--optype'} eq "newclone"));
  die " Usage: perl actAGMDBM.pl --type clone \n [--optype <newclone>] \n --dbname <source database name> \n [--remoteApp <no|yes>] \n --TargetDBname <app-aware mount database name> \n --OSusername <OS oracle owner> \n --TargetOracleHome <Target Oracle Home> \n --listenerpath <Target Oracle Listener path> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--SharedPoolSize <shared pool size in MB>] \n [--DBcacheSize <DB cache size in MB>] \n [--DBrecoveryFileDestSize <DB Recovery file dest size in MB>] \n [--Processes <Number of Processes>] \n [--OpenCursors <Max Number of Cursors>] \n [--DiagnosticDestination <Diagnostic Destination>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--redosize <redo size in MB>] \n [--recovery <yes|no>] \n [--envvar <variable1:variable2>] \n  [--backuplabel <backup label ID>] \n [--backuplabel <backup label ID>] \n [--standalone <yes|no>] \n  [--mountpoint <filesystem mountpoint '/act/mnt'>] \n [--DoNotUpdateTNSname <flag to update TNSentry yes|no>] \n [--DoNotchangeDBid <flag to change DBID yes|no>] \n [--template <child db protect template name>] \n [--profile <child db protect profile name>] \n --AGM <AGM ip|name> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--OSusername'} ) && ($arghash{'--optype'} eq "newclone"));

  #print "***************** Clone ******************\n";
  $dbname=$arghash{'--dbname'};
  $osuser=$arghash{'--OSusername'};
  $tdbname=$arghash{'--TargetDBname'};
  $torahome=$arghash{'--TargetOracleHome'};
  $ttnsadmin=$torahome . '/network/admin';
  $AGMip=$arghash{'--AGM'};
  $sourceHost=`hostname`;
  $sourceHost =~ s/(\w+)\..*/\1/;
  $sourceHost =~ s/^\s+|\s+$//g;
  $optype="newclone";
  $targetHost=`hostname`;
  $targetHost =~ s/(\w+)\..*/\1/;
  $targetHost =~ s/^\s+|\s+$//g;
  $pointInTime="";
  $openDB="yes";
  $asmDG="";
  $RACNodeList="";
  #$torahome=$sorahome;
  #$tdbname=$dbname;
  $dbmemory="";
  $temptabsize="";
  $pnewapp="false";
  #$osuser="oracle";
  #$ospassword="12%21pass345";
  $rrecovery="true";
  $standalone="false";
  $donotupdatetns="false";
  $donotupdateDBid="false";

  if ( exists $arghash{'--sourceHost'} ) {
        $sourceHost=$arghash{'--sourceHost'};
    }
  if ( exists $arghash{'--optype'} ) {
        $optype=$arghash{'--optype'};
    }
  if ( exists $arghash{'--targetHost'} ) {
        $targetHost=$arghash{'--targetHost'};
    }
  if ( exists $arghash{'--imageType'} ) {
        $imagetype=$arghash{'--imageType'};
    }
  if ( exists $arghash{'--pointInTime'} ) {
        $pointInTime=$arghash{'--pointInTime'};
        if ($pointInTime=~/\d{4,4}\-\d{2,2}\-\d{2,2}\s+\d{2,2}\:\d{2,2}\:\d{2,2}/) {
            #print "recovery time is " . $pointInTime ."\n";
        }
        else {
            die "Date and Time format is not matching with yyyy-mm-dd HH24:MI:SS";
        }
    }

  if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
  if ( exists $arghash{'--openDB'} ) {
        $openDB=$arghash{'--openDB'};
    }
  if ( exists $arghash{'--ASMdiskgroup'} ) {
        $asmDG=$arghash{'--ASMdiskgroup'};
    }
  if ( exists $arghash{'--RACNodeList'} ) {
        $RACNodeList=$arghash{'--RACNodeList'};
        #$RACNodeList=~s/\:/%3A/g;
        printf $RACNodeList . "\n";
    }

  if ( exists $arghash{'--TargetDBname'} ) {
        $tdbname=$arghash{'--TargetDBname'};
    }
  if ( exists $arghash{'--TargetOracleHome'} ) {
        $torahome=$arghash{'--TargetOracleHome'};
        #$torahome=~s/\//%2F/g;
    }
  if ( exists $arghash{'--databaseMemory'} ) {
        $dbmemory=$arghash{'--databaseMemory'};
    }
  if ( exists $arghash{'--OSusername'} ) {
        $osuser=$arghash{'--OSusername'};
    }
  if ( exists $arghash{'--listenerpath'} ) {
        $ttnsadmin=$arghash{'--listenerpath'};
        #$ttnsadmin=~s/\//%2F/g;
    }
  if ( exists $arghash{'--TemptablespaceSize'} ) {
        $temptabsize=$arghash{'--TemptablespaceSize'};
    }
  if ( exists $arghash{'--protectNewApplication'} ) {
        $pnewapp=$arghash{'--protectNewApplication'};
    }
  if ( exists $arghash{'--totalmemory'} ) {
        $tmemory=$arghash{'--totalmemory'};
    }
  if ( exists $arghash{'--SGApct'} ) {
        $sgap=$arghash{'--SGApct'};
    }
  if ( exists $arghash{'--SharedPoolSize'} ) {
        $sharedpool=$arghash{'--SharedPoolSize'};
    }
  if ( exists $arghash{'--DBcacheSize'} ) {
        $dbcache=$arghash{'--DBcacheSize'};
    }
  if ( exists $arghash{'--DBrecoveryFileDestSize'} ) {
        $dbrfds=$arghash{'--DBrecoveryFileDestSize'};
    }
  if ( exists $arghash{'--Processes'} ) {
        $process=$arghash{'--Processes'};
    }
  if ( exists $arghash{'--OpenCursors'} ) {
        $opencursor=$arghash{'--OpenCursors'};
    }
  if ( exists $arghash{'--DiagnosticDestination'} ) {
        $diagdest=$arghash{'--DiagnosticDestination'};
    }
  if ( exists $arghash{'--tnsip'} ) {
        $tnslip=$arghash{'--tnsip'};
    }
  if ( exists $arghash{'--tnsport'} ) {
        $tnsport=$arghash{'--tnsport'};
    }
  if ( exists $arghash{'--tnsdomain'} ) {
        $tnsdomain=$arghash{'--tnsdomain'};
    }
  if ( exists $arghash{'--redosize'} ) {
        $redosize=$arghash{'--redosize'};
    }
  if ( exists $arghash{'--recovery'} ) {
        $rrecovery=$arghash{'--recovery'};
    }
  if ( exists $arghash{'--envvar'} ) {
        $envvar=$arghash{'--envvar'};
        @envvararray = split /:/, $envvar;
        $env = $envvararray[0];
        $dbtype = $envvararray[1];
    }
  if ( exists $arghash{'--backuplabel'} ) {
        $bkplabelid=$arghash{'--backuplabel'};
    }
  if ( exists $arghash{'--recovery'} ) {
        $rrecovery=$arghash{'--recovery'};
    }
  if ( exists $arghash{'--standalone'} ) {
        $standalone=$arghash{'--standalone'};
    }
  if ( exists $arghash{'--template'} ) {
        $template=$arghash{'--template'};
    }
  if ( exists $arghash{'--profile'} ) {
        $profile=$arghash{'--profile'};
    }

  if ( exists $arghash{'--mountpoint'} ) {
        $mountpoint=$arghash{'--mountpoint'};
    }

  if ( exists $arghash{'--DoNotUpdateTNSname'} ) {
        $donotupdatetns=$arghash{'--DoNotUpdateTNSname'};
    }
  if ( exists $arghash{'--DoNotchangeDBid'} ) {
        $donotupdateDBid=$arghash{'--DoNotchangeDBid'};
    }

  if ( !exists $arghash{'--remoteApp'} ) {
        $remoteapp="no";
    }
  elsif ( exists $arghash{'--remoteApp'} ) {
        $remoteapp=$arghash{'--remoteApp'};
    }

  if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
  elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

  if ($pnewapp eq "yes") {
	   $pnewapp="true";
     }
  elsif ($pnewapp eq "no") {
         $pnewapp="false";
     }

  if ($rrecovery eq "yes") {
        $rrecovery="true";
     }
  elsif ($rrecovery eq "no") {
         $rrecovery="false";
     }

  if ($standalone eq "yes") {
        $standalone="true";
     }
  elsif ($standalone eq "no") {
         $standalone="false";
     }

  if ($donotupdateDBid eq "yes") {
        $donotupdateDBid="true";
     }
  elsif ($donotupdateDBid eq "no") {
         $donotupdateDBid="false";
     }

  if ($donotupdatetns eq "yes") {
        $donotupdatetns="true";
     }
  elsif ($donotupdatetns eq "no") {
         $donotupdatetns="false";
     }
  if( ( (!exists $arghash{'--template'}) || (!exists $arghash{'--profile'}) ) && $pnewapp eq "true" ) {
    die "\nMust need to specifi --template and --profile, if --protectNewApplication is true\n";
  }
  if ($optype eq "newclone") {
    clone();
    }
  elsif ($optype eq "refresh") {
  	die "Usage: perl actAGMDBM.pl --type clone --optype refresh \n --dbname <source database name> \n --TargetDBname <app-aware mount database name> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--backuplabel <backup label ID>] \n --AGM <AGM ip|name> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--optype'} eq "refresh") && ($arghash{'--type'} eq "clone") );
    if (($tdbname eq "")  || ($dbname eq "") || ($AGMip eq "")) {
  	die "Usage: perl actAGMDBM.pl --type clone --optype refresh \n --dbname <source database name> \n --TargetDBname <app-aware mount database name> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--backuplabel <backup label ID>] \n --AGM <AGM ip|name> \n [--wait <yes|no>]\n";
       }
       print "reprovision option is for workflow only \n";
       #reprovision();
   }


} #end of if - clone

if($arghash{'--type'} eq "cleanup") {
    die "Usage:actAGMDBM --type cleanup \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "cleanup") );
    die "Usage:actAGMDBM --type cleanup \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--appName'} ) || ( !exists $arghash{'--sourceHost'} ) || ( !exists $arghash{'--targetHost'} )) && ($arghash{'--type'} eq "cleanup") );
    $appname=$arghash{'--appName'};
    $image="";
    $targetHost="";
    $AGMip=$arghash{'--AGM'};

    if ( exists $arghash{'--sourceHost'} ) {
        $sourceHost=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--imageName'} ) {
        $image=$arghash{'--imageName'};
    }
    if ( exists $arghash{'--targetHost'} ) {
        $targetHost=$arghash{'--targetHost'};
    }
    if ( exists $arghash{'--targetAppName'} ) {
        $taname=$arghash{'--targetAppName'};
        #$taname =~ s/(.)/\u$1/g;
    }
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

    cleanup();
}

if($arghash{'--type'} eq "runwf") {
  die "Usage:actAGMDBM.pl --type runwf \n --subtype directmount \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "directmount") );
  die "Usage:actAGMDBM.pl --type runwf \n --subtype [<directmount|liveclone>] \n" if ( ((exists $arghash{'--help'}) || (!exists $arghash{'--help'}) ) && ($arghash{'--type'} eq "runwf") && ( !exists $arghash{'--subtype'}) );
  die "Usage:actAGMDBM.pl --type runwf \n --subtype directmount \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "directmount") );
  die "Usage:actAGMDBM.pl --type runwf \n --subtype directmount \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--dbname'} ) || ( !exists $arghash{'--hostname'} ) || ( !exists $arghash{'--wfname'} ) ) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "directmount") );

  if ($arghash{'--subtype'} eq "liveclone") {
    die "Usage:actAGMDBM.pl --type runwf \n --subtype liveclone \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n [--refreshliveclone <yes|no>] \n [--provisionliveclone <yes|no>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "liveclone") );
    die "Usage:actAGMDBM.pl --type runwf \n --subtype liveclone \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n [--refreshliveclone <yes|no>] \n [--provisionliveclone <yes|no>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--dbname'} ) || ( !exists $arghash{'--hostname'} ) || ( !exists $arghash{'--wfname'} ) ) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "liveclone") );
  }

  $subtype=$arghash{'--subtype'};
  $wfname=$arghash{'--wfname'};
  $dbname=$arghash{'--dbname'};
  $hostname=$arghash{'--hostname'};
  $AGMip = $arghash{'--AGM'};
  $reprov=$arghash{'--reprovision'};
  $reflive="";
  $provlive="";

  if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
  }
  if ( exists $arghash{'--refreshliveclone'} ) {
        $reflive=$arghash{'--refreshliveclone'};
  }
  if ( exists $arghash{'--provisionliveclone'} ) {
        $provlive=$arghash{'--provisionliveclone'};
  }
  if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
  }
  else {
        $statuswait=$arghash{'--wait'};
  }
  if ($reflive eq "yes") {
        $reflive="false";
  }
  elsif ($reflive eq "no") {
         $reflive="true";
  }
  if ($provlive eq "yes") {
        $provlive="fasle";
  }
  elsif ($provlive eq "no") {
         $provlive="true";
  }

  runwf();
}

sub getSessionID {

   $pwd = cwd();
    @sesdir = ("$pwd",);
    $count=0;
    File::Find::find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};
      #print "AGM in file " . $AGMips . "\n";
    $detfile=$pwd . "/" . $AGMips . "_details";
   if ($count == 1) {
    $sesfile=$userfile;
  }
   if ($count > 1) {
    $sesfile=$detfile;
  }
  if (!-e $sesfile) {
   die "AGM user details file is missing\n";
  }
   #print "count is " . $count . "\n";
   #print "session file is " . $sesfile . "\n";
    $retuser = retrieve ($sesfile);
    my $username = $retuser -> {username};
    my $password_en = $retuser -> {password};

    my $password_de = MIME::Base64::decode($password_en);
    my $pass_enc = uri_escape($password_de);

my %token=`curl -XPOST --user $username:$pass_enc --tlsv1.2 -k -s https://$AGMips/actifio/session`;

foreach my $key (%token) {
if ($key =~ /session_id/) {
my @session = split(':', $key);
#print "The session id is" . $session[1] . "\n";
my $sessionid = $session[1];
return $sessionid;
  }
 }

} #end of sub getSessionID()

sub mount {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

if ( $appid eq "" ) {
die "could not get appID \n";
}

my $jobclass;
my $backupname;
my $bkpid;
my $mntjobid;

if ($image eq "") {
   $bkpname = getLatestImage();
  # @bkparray = split /:/, $bkpstring;
  # $imageid = $bkparray[0];
  # $bkpname = $bkparray[1];
  # print "image id is " . $imageid ."\n";
   print "image name is " . $bkpname ."\n";
 }
 else {
     $bkpname=$image;
 }

 if ( $bkpname eq "" ) {
     die "could not get latest imagename\n";
    }

my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=backupname:==$bkpname"`;

foreach my $p (@imgdetails) {

#print $p . "\n";

if ($p =~ /\bid\b/) {
my @backup = split(':', $p);
$backupid =  $backup[1];
$backupid =~ s/,$//;
$backupid =~ s/\"//g;
$backupid =~ s/^\s+|\s+$//g;
print "Image ID:  " . $backupid . "\n";
$bkpid = $backupid;
last;
    }

}
print "backup id is " . $bkpid . "\n";

$hostname=$targetHost;
my $hostid=getHostID();
print "host id is " . $hostid . "\n";

if ( ($asmDG ne "") && ($RACNodeList ne "") && ($mountpoint ne "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait": "true","image": "$bkpname","hostname": "$targetHost","host": {"id": "$hostid"},"restoreoptions": [{"name":"volgroupname","value":"$asmDG"}, {"name":"asmracnodelist","value":"$RACNodeList"}, {"name":"mountpointperimage","value":"$mountpoint"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($asmDG ne "") && ($RACNodeList ne "") && ($mountpoint eq "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait": "true","image": "$bkpname","hostname": "$targetHost","host": {"id": "$hostid"},"restoreoptions": [{"name":"volgroupname","value":"$asmDG"}, {"name":"asmracnodelist","value":"$RACNodeList"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($asmDG ne "") && ($RACNodeList eq "") && ($mountpoint eq "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait": "true","image": "$bkpname","hostname": "$targetHost","host": {"id": "$hostid"},"restoreoptions": [{"name":"volgroupname","value":"$asmDG"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($asmDG eq "") && ($RACNodeList ne "")  && ($mountpoint eq "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait": "true","image": "$bkpname","hostname": "$targetHost","host": {"id": "$hostid"},"restoreoptions": [{"name":"asmracnodelist","value":"$RACNodeList"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($asmDG eq "") && ($mountpoint ne "") && ($RACNodeList eq "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait": "true","image": "$bkpname","hostname": "$targetHost","host": {"id": "$hostid"},"restoreoptions": [{"name":"mountpointperimage","value":"$mountpoint"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($asmDG eq "") && ($mountpoint eq "") && ($RACNodeList eq "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait": "true","image": "$bkpname","hostname": "$targetHost","host": {"id": "$hostid"}}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

#print "curl -XPOST -k --tlsv1.2 -H Authorization: Actifio " . $sessionid . "-H Content-Type: application/json -d {nowait: true,image: " . $bkpname . ",hostname: " . $targetHost . "host: {id: " . $hostid . "}} https://" . $AGMips . "/actifio/backup/" . $bkpid . "/mount\n";

print @mountdet . "\n";

if ( @mountdet == 0 ) {
sleep(15);
my @mountjob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=appname:==$appname&filter=status:==running&filter=jobclasscode:==5"`;

foreach my $j (@mountjob) {
if ($j =~ /jobname/) {
my @mntj = split(':', $j);
my $mntjid =  $mntj[1];
$mntjid =~ s/,$//;
$mntjid =~ s/\"//g;
$mntjid =~ s/^\s+|\s+$//g;
$mntjobid = $mntjid;
print "Mount JobName:     " . $mntjobid . "\n";
last;
}
 }


print "Mount Job " . $mntjobid . " submitted Successfully\n";
}

if ( @mountdet > 0 ) {
die "Mount Job submission failed\n";
}
my $job_stat;
my @jobstatarray;

if ( ( @mountdet == 0 ) && ($statuswait eq "yes") ) {

        $job_stat = jobStatus($mntjobid);

         @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( ( $job_error ne "10016" ) && ( $job_status eq "running" ) )  {
            sleep(60);
            $job_stat = jobStatus($mntjobid);
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
            print $job_status . "\n";
        }

        if ( $job_error eq "10016" ) {

            my @jobhiststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobhistory?filter=jobname:==$mntjobid"`;

foreach my $j (@jobhiststat) {
if ($j =~ /\bstatus\b/) {
#if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Mount Job:     " . $mntjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobhiststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Mount Job:     " . $mntjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }
}
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            print "Mount Job " . $mntjobid . " is " . $job_status . "\n";
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Mount Job " . $mntjobid . " is " . $job_status . "\n";
        }
         exit $re_code;
    }

} #end of sub mount()

sub getLatestImage {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

print "\n";

if ($imagetype eq "") {
   $imagetype="snapshot";
}

my $jobclass;
my $backupname;
my $beginpit;
my $endpit;
my $bpit;
my $epit;

print "image type is " . $imagetype . "\n";
my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==$imagetype&filter=hostname:==$hostname"`;

foreach my $p (@imgdetails) {

#print $p;

if ($p =~ /\bbackupname\b/) {
my @backup = split(':', $p);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Image Name:  " . $backupname . "\n";
return $backupname;
    }
  }
}


} #end of sub getLatestImage()

sub listAppliance {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

print "\n";

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname"`;

my @arr;
my $f;

if ( @appdetails < 4 ) {
print "Application Name: " . $appname . " not found\n";
}

foreach my $k (@appdetails) {
#print $k;
if ($k =~ /\@type/) {
$f = 1;
}

if ($f == 1) {
push(@arr, $k);
}

if ($k =~ /hostname/) {
	$f = 0;
}
#continue;
#last;
}


#print @arr;
my $flag;
foreach my $p (@arr) {
#print $p;
$flag = 0;
if ($p =~ /$appname/) {
$flag = 1;
}
if (defined($flag) & $p =~ /\bname\b/) {
my @appliance = split(':', $p);
my $appliancename =  $appliance[1];
$appliancename =~ s/,$//;
$appliancename =~ s/\"//g;
$appliancename =~ s/^\s+|\s+$//g;
if ( $appliancename ne $appname ) {
print "\n";
print "Application Name:     " . $appname . "\n";
print "Appliance Name:       " . $appliancename . "\n";
 }
}
if (defined($flag) & $p =~ /\bipaddress\b/) {
my @ipadd = split(':', $p);
my $ipaddress = $ipadd[1];
$ipaddress =~ s/,$//;
$ipaddress =~ s/\"//g;
$ipaddress =~ s/^\s+|\s+$//g;
print "Appliance IPAddress:  " . $ipaddress . "\n";
}

if (defined($flag) & $p =~ /\btype\b/) {
my @appt = split(':', $p);
my $apptype = $appt[1];
$apptype =~ s/,$//;
$apptype =~ s/\"//g;
$apptype =~ s/^\s+|\s+$//g;
if ( ( $apptype eq  "CDS" ) || ( $apptype eq  "Sky" ) ) {
print "Appliance Type:       " . $apptype . "\n";
 }
}

if (defined($flag) & $p =~ /\bhostname\b/) {
  my @hname = split(':', $p);
  my $hostname = $hname[1];
  $hostname =~ s/,$//;
  $hostname =~ s/\"//g;
  $hostname =~ s/^\s+|\s+$//g;
print "Host Name:            " . $hostname . "\n";
  }

}

} #end of sub listAppliance()

sub getHostID {

my @arr;
my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

print "host name " . $hostname . "\n";
my @hostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;
#my @hostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/host?filter=hostname:==$hostname"`;

foreach my $k (@hostdetails) {
#print $k;
if ($k =~ /\bhost\b/) {
$f = 1;
}

if ($f == 1) {
push(@arr, $k);
}

if ($k =~ /\bdbauthentication\b/) {
       # $f = 0;
last;
}
#continue;
#last;
}

foreach my $p (@arr) {
#print $p . "\n";

if ($p =~ /\bid\b/) {
my @hosti = split(':', $p);
my $hostid =  $hosti[1];
$hostid =~ s/,$//;
$hostid =~ s/\"//g;
$hostid =~ s/^\s+|\s+$//g;
print "Host ID:     " . $hostid . "\n";
return $hostid;
last;
}
}
} #end of sub getHostID()

sub getAppID {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

print "host name " . $hostname . "\n";

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;

foreach my $k (@appdetails) {
#print $k;
push(@arr, $k);
#if ($k =~ /},/) {
#last;
# }
}
#print @arr;
my $flag;
foreach my $p (@arr) {
#print $p . "\n";
$flag = 0;
if ( ($p =~ /$appname/) && ($p =~ /$hostname/) ) {
$flag = 1;
}

if (defined($flag) & $p =~ /id/) {
my @appi = split(':', $p);
my $appid =  $appi[1];
#print "App ID:     " . $appid . "\n";
return $appid;
}
}
} #end of sub getAppID()

sub backup {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}
my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
print "AppID is " . $appid . "\n";
print "\n";
if ( $appid eq "" ) {
die "could not get appID \n";
}

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;

if ( @appdetails < 4 ) {
print "Application Name: " . $appname . " not found\n";
}

my $sltf;
my $sltid;
my $slpf;
my $bkpjobid;
my $job_status;
my $job_errmsg;

foreach my $k (@appdetails) {
if ($k =~ /slt/) {
$flag=1;
}
if (defined($flag) & $k =~ /name/) {
my @slti = split(':', $k);
my $sltn =  $slti[1];
$sltn =~ s/,$//;
$sltn =~ s/\"//g;
$sltn =~ s/^\s+|\s+$//g;
$sltf = $sltn;
print "slt:     " . $sltn . "\n";
last;
}
 }

foreach my $i (@appdetails) {
if ($i =~ /slt/) {
$iflag=1;
}
if (defined($iflag) & $i =~ /id/) {
my @sltin = split(':', $i);
my $slti =  $sltin[1];
$slti =~ s/,$//;
$slti =~ s/\"//g;
$slti =~ s/^\s+|\s+$//g;
$sltid = $slti;
print "sltID:     " . $sltid . "\n";
last;
}
 }

foreach my $s (@appdetails) {
if ($s =~ /slp/) {
$sflag=1;
}
if (defined($sflag) & $s =~ /name/) {
my @slpi = split(':', $s);
my $slpn =  $slpi[1];
$slpn =~ s/,$//;
$slpn =~ s/\"//g;
$slpn =~ s/^\s+|\s+$//g;
$slpf = $slpn;
print "slp:     " . $slpf . "\n";
last;
}
 }

my $policyid;
my $optype;
my @parr;
my $bkp_job_id;
my @policydet=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" https://$AGMips/actifio/slt/$sltid/policy`;

if ( @policydet < 4 ) {
print "Policy Details for " . $appname . " not found\n";
}

foreach my $p (@policydet) {
if ($p =~ /\@type/) {
$f = 1;
}

if ($f == 1) {
push(@parr, $p);
}

if ($p =~ /\bop\b/) {
        $f = 0;
}
#continue;
#last;
}
foreach my $p (@parr) {
#print $p;
if ($p =~ /id/) {
my @poli = split(':', $p);
my $polid =  $poli[1];
$polid =~ s/,$//;
$polid =~ s/\"//g;
$polid =~ s/^\s+|\s+$//g;
$policyid = $polid;
}
if ($p =~ /\bop\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$optype = $opt;
}
#print "operation type is " . $optype . "\n";
if ($optype eq "snap") {
print "PolicyID:     " . $policyid . "\n";
last;
}
}

print $policyid . "\n";

my @backupdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"policy": {"id": "$policyid"},"backuptype": "$bkptype"}' https://$AGMips/actifio/application/$appid/backup 2>/dev/null`;


if ( $backuplabel ne "" ) {
my @backupdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"policy": {"id": "$policyid"},"backuptype": "$bkptype","label":"$backuplabel"}' https://$AGMips/actifio/application/$appid/backup 2>/dev/null`;
}

#print @backupdet . "\n";

if ( @backupdet == 0 ) {
sleep(15);
my @backupjob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=appname:==$appname&filter=hostname:==$hostname&filter=jobclasscode:==1"`;
foreach my $j (@backupjob) {
#print $j . "\n";
if ($j =~ /id/) {
my @bkpji = split(':', $j);
my $bkpjoid =  $bkpji[1];
$bkpjoid =~ s/,$//;
$bkpjoid =~ s/\"//g;
$bkpjoid =~ s/^\s+|\s+$//g;
$bkp_job_id = $bkpjoid;
print "Backup Job Id:     " . $bkp_job_id . "\n";
last;
}
}
foreach my $j (@backupjob) {
if ($j =~ /jobname/) {
my @bkpj = split(':', $j);
my $bkpjid =  $bkpj[1];
$bkpjid =~ s/,$//;
$bkpjid =~ s/\"//g;
$bkpjid =~ s/^\s+|\s+$//g;
$bkpjobid = $bkpjid;
print "Backup JobName:     " . $bkpjobid . "\n";
last;
}
 }


my @jobstata=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=jobname:==$bkpjobid"`;

foreach my $s (@jobstata) {
if ($s =~ /\bstatus\b/) {
#if ($s =~ /status/) {
my @jobst = split(':', $s);
my $jobstatf =  $jobst[1];
$jobstatf =~ s/,$//;
$jobstatf =~ s/\"//g;
$jobstatf =~ s/^\s+|\s+$//g;
$jobstatusf = $jobstatf;
print "Backup Job: " . $bkpjobid . "\t Status: " . $jobstatusf . " submitted\n";
print "\n";
last;
}
 }

#print "job status is " . $jobstatusf . "\n";
#print "job priority input " . $jobpriority . "\n";

my $jobprflag;
if ( ($jobpriority ne "") && ($jobstatusf eq "queued") ) {
   #my @jobbkppri=`curl -XPOST -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/job/$bkpjobid"`;
my @jobbkppri=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"priority":"$jobpriority"}' https://$AGMips/actifio/job/$bkp_job_id  2>/dev/null`;

sleep 5;
#print "priority change " . @jobbkppri . "\n";

foreach my $p (@jobbkppri) {
   if ($p =~ /changerequesttext/) {
my @jobpr = split(':', $p);
my $jobprf =  $jobpr[1];
$jobprf =~ s/,$//;
$jobprf =~ s/\"//g;
$jobprf =~ s/^\s+|\s+$//g;
$jobprflag = $jobprf;
#print "job priority flag inside " . $jobprflag . "\n";
last;
}
   }
if ( $jobprflag == "CHANGEPRIORITY" ) {
printf "Backup job " . $bkpjobid . " priority change request submitted to " . $jobpriority . "\n";
}

}
#print "Backup Job " . $bkpjobid . " submitted Successfully\n";
}

if ( @backupdet > 0 ) {
die "Backup Job submission failed\n";
}
my $job_stat;
my @jobstatarray;

if ( ( @backupdet == 0 ) && ($statuswait eq "yes") ) {

        $job_stat = jobStatus($bkpjobid);

         @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( ( $job_error ne "10016" ) && ( $job_status eq "running" ) )  {
            sleep(60);
            $job_stat = jobStatus($bkpjobid);
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
            print $job_status . "\n";
        }

        if ( $job_error eq "10016" ) {

            my @jobhiststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobhistory?filter=jobname:==$bkpjobid"`;

foreach my $j (@jobhiststat) {
if ($j =~ /\bstatus\b/) {
#if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobhiststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }
}
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            print "Backup Job " . $bkpjobid . " is " . $job_status . "\n";
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Backup Job " . $bkpjobid . " is " . $job_status . "\n";
        }
         exit $re_code;
    }

} #end of sub backup()

my $job_error;
my $jobstatus;
my $joberrc;

sub jobStatus {

$bkpjobid = $_[0];

#my $jobstatus;
#my $joberrc;

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

my @jobststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=jobname:==$bkpjobid"`;

foreach my $j (@jobststat) {
if ($j =~ /\bstatus\b/) {
#if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }

return $jobstatus .":". $joberrc;
} #end of sub jobStatus()

sub listImageDetails {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

if ( $appid eq "" ) {
die "could not get appID \n";
}

my $jobclass;
my $backupname;
my $beginpit;
my $endpit;
my $bpit;
my $epit;

my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==snapshot&filter=hostname:==$hostname"`;

#my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname"`;

print "Database Name: " . $appname . "\n";
print "Host Name: " . $hostname . "\n";
print "\n";

foreach my $p (@imgdetails) {

#print $p;

#if ( $p =~ /\bjobclass\b/ ) {
#my @jobcl = split(':', $p);
#$jobclass = $jobcl[1];
#$jobclass =~ s/,$//;
#$jobclass =~ s/\"//g;
#$jobclass =~ s/^\s+|\s+$//g;
#print "Job Type:  " . $jobclass . "\n";
# }

if ($p =~ /\bbackupname\b/) {
my @backup = split(':', $p);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Snapshot Image and Recovery Range \n";
#print "Image Type:  " . Snapshot . "\n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($p =~ /beginpit/) {
my @beginp = split(':', $p);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
  }
if ($p =~ /endpit/) {
my @endp = split(':', $p);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));
#print $endpit;
# }

if ( defined($beginpit) && defined($endpit) ) {
#print "Snapshot Image and Recovery Range \n";
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
}

my @dedetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==dedup&filter=hostname:==$hostname"`;

foreach my $q (@dedetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Dedup Image and Recovery Range \n";
#print "Image Type:  " . Dedup . "\n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
#print "Dedup Image and Recovery Range \n";
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @livedetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==liveclone&filter=hostname:==$hostname"`;

foreach my $q (@livedetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "LiveClone Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @dasdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==dedupasync&filter=hostname:==$hostname"`;

foreach my $q (@dasdetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "DedupAsync Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @sspdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==StreamSnap&filter=hostname:==$hostname"`;

foreach my $q (@sspdetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "StreamSnap Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

} #end of sub listImageDetails()

#------------------------------------------------------------------------------------------------------------------------
#getLatestMountImage($sessionid,$AGMip,$appid,$tappid)
#------------------------------------------------------------------------------------------------------------------------
sub getLatestMountImage {
  my ($sessionid,$AGMip,$appname,$tappid) = @_;
  my @mntImgs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==mount"`;
  #print "@mntImgs \n";
  foreach my $x (@mntImgs) {
    if($x =~ /\bbackupname\b/) {
      #print $x;
      my @bkpnameT=split(':',$x);
      $bkpname=$bkpnameT[1];
      $bkpname=~ s/,$//;
      $bkpname=~ s/\"//g;
      $bkpname=~ s/^\s+|\s+$//g;
    }
    if($x =~ /\bid\b/ && $x =~ /\b$tappid\b/ ) { last; }
  }
  print "Image name: $bkpname\n";
  return $bkpname;
}
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# getImagebyLabel($sessionid,$AGMip,$backlabel,$appname)
#------------------------------------------------------------------------------------------------------------------------
sub getImagebyLabel {
  my ($sessionid,$AGMips,$backlabel,$appname) = @_;
  my @bkpImgs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=label:==$backlabel"`;
  #print "@bkpImgs \n";
  foreach my $x (@bkpImgs) {
    if($x =~ /\bbackupname\b/) {
      #print $x;
      my @bkpnameT=split(':',$x);
      $bkpname=$bkpnameT[1];
      $bkpname=~ s/,$//;
      $bkpname=~ s/\"//g;
      $bkpname=~ s/^\s+|\s+$//g;
      return $bkpname;
    }
  }

} #end of sub getImagebyLabel
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# getImageRRbyName($sessionid,$AGMip,$bkpname)
#------------------------------------------------------------------------------------------------------------------------
sub getImageRRbyName {
  my ($sessionid,$AGMips,$bkpname) = @_;
  my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/backup?filter=backupname:==$bkpname"`;
  #print "@imgdetails \n";
  foreach my $x (@imgdetails) {
    if($x =~ /\bendpit\b/) {
      #print $x;
      my @endPitT=split(':',$x);
      $endpit=$endPitT[1];
      $endpit=~ s/,$//;
      $endpit=~ s/\"//g;
      $endpit=~ s/^\s+|\s+$//g;
      use POSIX qw( strftime );
      $epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));
      return "$epit";
    }
  }
} #end of sub getImageRRbyName
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# getHostIP($sessionid,$AGMip,$hostname);
#------------------------------------------------------------------------------------------------------------------------
sub getHostIP {
  my ($sessionid,$AGMip,$hostname) = @_;
  my @hostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/host?filter=hostname:==$hostname"`;
  #print "@hostdetails \n";
  $ip;
  foreach my $x (@hostdetails) {
    if($x =~ /\bipaddress\b/) {
      my @iptag=split(':',$x);
      $ip=$iptag[1];
      $ip=~ s/,$//;
      $ip=~ s/\"//g;
      $ip=~ s/^\s+|\s+$//g;
      #print "ip: $ip \n";
      last;
    }
  }
  return $ip;
}
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# clone()
#------------------------------------------------------------------------------------------------------------------------
sub clone {
  #get sessionID
  my $sessionid = getSessionID();
  $sessionid =~ s/,$//;
  $sessionid =~ s/\"//g;
  $sessionid =~ s/^\s+|\s+$//g;
  if ( $sessionid eq "" ) { die "Authentication is not established\n"; }
  #print "sessionID: $sessionid \n";

  $hostname=$sourceHost;  #print "hostname[sourceHost]: $sourceHost\n";
  $appname=$dbname;       #print "appname[dbname]: $appname \n";

  # Get application ID
  my $applid;
  my $appid = getAppID();
  $appid =~ s/,$//;
  $appid =~ s/\"//g;
  $appid =~ s/^\s+|\s+$//g;
  $applid = $appid;
  if($appid eq "") { die "ERROR: not able to get source appID\n" }

  #Get image details
  if ($imagetype eq "") { $imagetype="snapshot"; }
  if ($image ne "") { $bkpname=$image; }
  if ( ($image eq "") && ($bkplabelid ne "") ) {
    $bkpname = getImagebyLabel($sessionid,$AGMip,$bkplabelid,$appname);
    print "Image name " . $bkpname ."\n";
  }

  if ( ($image eq "") && ($bkplabelid eq "") ) {
    $bkpname = getLatestImage();
  }
  if ( $bkpname eq "" ) { die "ERROR: could not get latest imagename\n"; }

  #get image id
  my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=backupname:==$bkpname"`;
  #print "@imgdetails \n";
  foreach my $p (@imgdetails) {
    if ($p =~ /\bid\b/) {
      my @backup = split(':', $p);
      $backupid =  $backup[1];
      $backupid =~ s/,$//;
      $backupid =~ s/\"//g;
      $backupid =~ s/^\s+|\s+$//g;
      #print "Image ID:  " . $backupid . "\n";
      $bkpid = $backupid;
      last;
    }
  }
  print "backup id is " . $bkpid . "\n";

  #get target hostid
  $hostname=$targetHost;
  my @hostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/host?filter=hostname:==$hostname"`;
  #print "@hostdetails\n";
  foreach my $x (@hostdetails) {
    if ($x =~ /\bid\b/){
      my @hostidT=split(':',$x);
      $hostid=$hostidT[1];
      $hostid=~ s/,$//;
      $hostid=~ s/\"//g;
      $hostid=~ s/^\s+|\s+$//g;
      print "Target host id: $hostid\n";
      last;
    }
  }
  if($hostid eq "") { die "ERROR: not able go get target host id\n"; }

  if($pointInTime eq "") {
    $pointInTime=getImageRRbyName($sessionid,$AGMips,$bkpname);
  }
  if($pointInTime ne "") { print "Recovery upto $pointInTime \n"; }

  my $provisioningOptions = '{"name":"databasesid","value":"'.$tdbname.'"}, {"name":"username","value":"'.$osuser.'"}, {"name":"orahome","value":"'.$torahome.'"}, {"name":"tnsadmindir","value":"'.$ttnsadmin.'"}, {"name":"diagnostic_dest","value":"'.$diagdest.'"}, {"name":"processes","value":"'.$process.'"}, {"name":"open_cursors","value":"'.$opencursor.'"}, {"name":"tnsip","value":"'.$tnslip.'"}, {"name":"tnsdomain","value":"'.$tnsdomain.'"}, {"name":"nonid","value":"'.$donotupdateDBid.'"}, {"name":"notnsupdate","value":"'.$donotupdatetns.'"}, {"name":"rrecovery","value":"'.$rrecovery.'"}, {"name":"envvar","value":"'.$envvar.'"}, {"name":"redosize","value":"'.$redosize.'"}, {"name":"shared_pool_size","value":"'.$sharedpool.'"}, {"name":"db_cache_size","value":"'.$dbcache.'"}, {"name":"db_recovery_file_dest_size","value":"'.$dbrfds.'"}' ;
  if ($tmemory ne "") { $provisioningOptions=$provisioningOptions . ',{"name":"totalmemory","value":"'.$tmemory.'"}' }
  if ($sgap ne "") { $provisioningOptions=$provisioningOptions . ',{"name":"sgapct","value":"'. $sgap .'"}'; }
  if ($tnsport ne "") { $provisioningOptions=$provisioningOptions . ',{"name":"tnsport","value":"'.$tnsport.'"}'; }
  if ($standalone eq "true" ) { $provisioningOptions=$provisioningOptions . ',{"name":"standalone","value":"'.$standalone.'"}'; }

  if ( ($template ne "") && ($profile ne "") && ($pnewapp eq "true") ) {
    my @sltDetail=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/slt?filter=name:==$template"`;
    #print "@sltDetail \n";
    foreach my $x (@sltDetail) {
      if($x =~ /\bid\b/) {
        my @sltT=split(':',$x);
        $sltID=$sltT[1];
        $sltID=~ s/,$//;
        $sltID=~ s/\"//g;
        $sltID=~ s/^\s+|\s+$//g;
        print "SLT id: $sltID\n";
        last;
      }
    }
    if($sltID eq "") { die "ERROR: not able to get template id \n"; }

    my @slpDetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/slp?filter=name:==$profile"`;
    #print "@slpDetails \n";
    foreach $x (@slpDetails) {
      if($x =~ /\bid\b/) {
        my @slpT=split(':',$x);
        $slpID=$slpT[1];
        $slpID=~ s/,$//;
        $slpID=~ s/\"//g;
        $slpID=~ s/^\s+|\s+$//g;
        print "SLP id: $slpID\n";
        last;
      }
    }
    if($slpID eq "") { die "ERROR: not able to get profile id \n"; }

    $provisioningOptions=$provisioningOptions . ',{"name":"reprotect","value":"true"},{"name":"slt","value":"'. $sltID .'"},{"name":"slp","value":"'. $slpID .'"}';
  }

  my $restoreOptions;
  if($mountpoint ne "") {
      $restoreOptions='{"name":"mountpointperimage","value":"'. $mountpoint .'"}'
  }
  if($asmDG ne "") {
    if($restoreOptions eq "") {
      $restoreOptions='{"name":"volgroupname","value":"'. $asmDG .'"}'
    }
    else {
      $restoreOptions=$restoreOptions . ',{"name":"volgroupname","value":"'. $asmDG .'"}'
    }
  }
  if($RACNodeList ne "") {
    if($restoreOptions eq "") {
      $restoreOptions='{"name":"asmracnodelist","value":"'. $RACNodeList .'"}'
    }
    else {
      $restoreOptions=$restoreOptions . ',{"name":"asmracnodelist","value":"'. $RACNodeList .'"}'
    }
  }
  #print "$restoreOptions \n";

  my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{
        "nowait":"true"
        ,"image":"$bkpname"
        ,"hostname":"$targetHost"
        ,"host": {"id":"$hostid"}
        ,"recoverytime":"$pointInTime"
        ,"restoreoptions":[$restoreOptions]
        ,"provisioningoptions":[$provisioningOptions]
        ,"appaware":"true"
        '} https://$AGMip/actifio/backup/$bkpid/mount 2>/dev/null`;
  #print "@mountdet \n";

  if ( @mountdet == 0 ) {
    sleep(15);
    my @mountjob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/jobstatus?filter=appname:==$appname&filter=status:==running&filter=jobclass:==mount"`;
    #print "@mountjob \n";
    foreach my $j (@mountjob) {
        if ($j =~ /jobname/) {
        my @mntj = split(':', $j);
        $jobName =  $mntj[1];
        $jobName =~ s/,$//;
        $jobName =~ s/\"//g;
        $jobName =~ s/^\s+|\s+$//g;
        print "Appaware mount JobName:     " . $jobName . "\n";
        last;
        }
      }
      print "Appaware mount Job " . $jobName . " submitted Successfully\n";
    }

  if ( @mountdet > 0 ) {
    die "Mount Job submission failed\n $mountdet[2]\n";
  }

  #wait if wait option specified
  if($statuswait eq "yes" && $jobName ne "") {
    waitForJob($sessionid,$AGMip,$jobName);
  }

} #end of clone()
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# cleanup()
#------------------------------------------------------------------------------------------------------------------------
sub cleanup {
  #get sessionID
  my $sessionid = getSessionID();
  $sessionid =~ s/,$//;
  $sessionid =~ s/\"//g;
  $sessionid =~ s/^\s+|\s+$//g;
  if ( $sessionid eq "" ) { die "Authentication is not established\n"; }
  #print "sessionID: $sessionid \n";

  #get sourch host id
  $hostname=$sourceHost;
  $hostid=getHostID();
  if ( $hostid eq "" ) {
        die "ERROR: could not get source hostid\n";
  }
  $shostid=$hostid;

  #get target host id
  my @hostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/host?filter=hostname:==$targetHost"`;
  #print "@hostdetails\n";
  foreach my $x (@hostdetails) {
    if ($x =~ /\bid\b/){
      my @hostidT=split(':',$x);
      $thostid=$hostidT[1];
      $thostid=~ s/,$//;
      $thostid=~ s/\"//g;
      $thostid=~ s/^\s+|\s+$//g;
      print "Target Host id: $thostid\n";
      last;
    }
  }
  if($thostid eq "") { die "ERROR: failed to get targetHost id\n"; }

  # get Image name which need to cleanup
  $sappname=$appname;
  $tappname=$taname;
  if ( ( $image eq "" ) && ( $taname eq "" ) ) {
        die "Error: either --imageName OR --targetAppName value must be provided \n";
  }
  elsif($image ne "") {
    $bkpname=$image;
    #print "Mounted Image going to delete is  " . $image . "\n";
  }
  else { #target app name is given
    $hostname=$targetHost;
    $appname=$tappname;
    $tappid=getAppID();
    $tappid =~ s/,$//;
    $tappid =~ s/\"//g;
    $tappid =~ s/^\s+|\s+$//g;
    #print "target appID: $tappid\n";
    if($tappid eq "") {
      die "ERROR: not able to get targetAppImage appid \n";
    }
    else {
      $bkpname = getLatestMountImage($sessionid,$AGMip,$sappname,$tappid)
    }
    #print "target host mounted image name is " . $bkpname . "\n";
  }

  if ( $bkpname eq "" ) {
        die "ERROR: could not get mounted imagename\n";
  }

  #get image id
  my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/backup?filter=backupname:==$bkpname"`;
  #print "@imgdetails \n";
  foreach my $p (@imgdetails) {
    if ($p =~ /\bid\b/) {
      my @backup = split(':', $p);
      $backupid =  $backup[1];
      $backupid =~ s/,$//;
      $backupid =~ s/\"//g;
      $backupid =~ s/^\s+|\s+$//g;
      #print "Image ID:  " . $backupid . "\n";
      $bkpid = $backupid;
      last;
    }
  }
  print "backup id is " . $bkpid . "\n";
  if($bkpid eq "") { die "ERROR: not able to get mounted image id\n"; }

  my @unmount=`curl -XPOST -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait":"true","delete":"true"}' "https://$AGMip/actifio/backup/$bkpid/unmount"`;
  print "@unmount \n";

  if ( @unmount == 0 ) {
    my @unmountJob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/jobstatus?filter=status:==running&filter=appname:==$sappname&filter=jobclass:==unmount-delete"`;
    #print "@unmountJob \n";
    foreach $x (@unmountJob) {
        if ($x =~ /\bjobname\b/) {
        my @mntj = split(':', $x);
        my $mntjid =  $mntj[1];
        $jobName =~ s/,$//;
        $jobName =~ s/\"//g;
        $jobName =~ s/^\s+|\s+$//g;
        print "Unmount-delete JobName:     " . $jobName . "\n";
        last;
        }
      }
      print "Unmount-detete Job " . $jobName . " submitted Successfully\n";
    }

  else {
    die "unMount Job submission failed\n $unmount[2]\n";
  }

  #wait if wait option specified
  if($statuswait eq "true" && $jobName ne "" ) {
    waitForJob($sessionid,$AGMip,$jobName);
  }

} #end of function - cleanup
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# runwf()
#------------------------------------------------------------------------------------------------------------------------
sub runwf {
  #get sessionID
  my $sessionid = getSessionID();
  $sessionid =~ s/,$//;
  $sessionid =~ s/\"//g;
  $sessionid =~ s/^\s+|\s+$//g;
  if ( $sessionid eq "" ) { die "Authentication is not established\n"; }

  $appname=$dbname;
  $hostid=getHostID();
  if($hostid eq "") { die "ERROR: not able to get hostid for host $hostname \n"; }

  #get app id
  $appid=getAppID();
  $appid=~ s/,$//;
  $appid=~ s/\"//g;
  $appid=~ s/^\s+|\s+$//g;
  if($appid eq "") { die "ERROR: not able to get appid for app $appname \n"; }
  print "Application id: $appid \n";

  # get backup image name
  if($image eq "") {
    $bkpname = getLatestImage();
  }
  else {
    $bkpname = $image;
  }
  if($bkpname eq "") { die "ERROR: not able to get backup image \n"; }
  $pointInTime=getImageRRbyName($sessionid,$AGMip,$bkpname);

  # get backup image srcid
  my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=backupname:==$bkpname"`;
  #print "@imgdetails \n";
  foreach my $p (@imgdetails) {
    if ($p =~ /\bsrcid\b/) {
      my @backup = split(':', $p);
      $backupid =  $backup[1];
      $backupid =~ s/,$//;
      $backupid =~ s/\"//g;
      $backupid =~ s/^\s+|\s+$//g;
      #print "Image ID:  " . $backupid . "\n";
      $bkpSrcID = $backupid;
      last;
    }
  }
  print "backup srcid is " . $bkpSrcID . "\n";

  # get workflow id
  my @wfURL=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/workflow?filter=name:==$wfname&filter=appname:==$appname"`;
  #print "@wfURL \n";
  foreach my $x (@wfURL) {
    if($x =~ /\bcount\b/) {
      my @cntT=split(':',$x);
      $cnt=$cntT[1];
      $cnt=~ s/,$//;
      $cnt=~ s/\"//g;
      $cnt=~ s/^\s+|\s+$//g;
      last;
    }
  }
  if($cnt eq 0 ) { die "ERROR: no workflow found with the name: $wfname \n"; }

  #get workflow id
  foreach my $x (@wfURL) {
    if($x =~ /\bid\b/) {
      my @idT=split(':',$x);
      $wfid=$idT[1];
      $wfid=~ s/,$//;
      $wfid=~ s/\"//g;
      $wfid=~ s/^\s+|\s+$//g;
      last;
    }
  }
  print "Workflow id: $wfid \n";

  my @wfDetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  #print "@wfDetails \n";

  # get schedule details
  $flag=0; $scheduleDetails="";
  foreach my $x (@wfDetails) {
    if($x =~ /\bschedule\b/) { $flag=1;}
    if($flag eq 1) { $scheduleDetails=$scheduleDetails.$x;  }
    if($flag eq 1 && $x =~ "}") { last; }
  }
  $scheduleDetails=~ s/\s+|\s$//g;
  $scheduleDetails=substr $scheduleDetails,0,length($scheduleDetails)-1;
  #print "$scheduleDetails \n";

  # get workflow props
  $flag=0; $wfProps="";
  foreach my $x (@wfDetails) {
    if( $x =~ /\bprops\b/ )  { $flag=1; }
    if ($x =~ /\bitems\b/) { last; }
    if($flag eq 1) { $wfProps = $wfProps . $x; }
  }
  $wfProps=~ s/\s+|\s$//g;                            # remove blank spaces
  $wfProps=substr $wfProps,0,length($wfProps)-1;      # remove , at the end
  # specify backup image in $wfProps
  $wfProps=(substr $wfProps,0,length($wfProps)-1).',{"key":"image","value":"'.$bkpSrcID.'"}'.']';
  #print "$wfProps \n";

  # get workflow items
  $flag=0; $wfItems="";
  foreach my $x (@wfDetails) {
    if( $x =~ /\bitems\b/ )  { $flag=1; }
    if ($x =~ /\bdisabled\b/) { last; }
    if($flag eq 1) { $wfItems = $wfItems . $x; }
  }
  $wfItems=~ s/\s+|\s$//g;                            # remove blank spaces
  $wfItems=substr $wfItems,0,length($wfItems)-1;      # remove , at the end

  #if workflow is for reprovision
  if($reprov eq "yes") {
    $repAppID=""; $repAppName="";

    #get reprovision app name
    $flag=0; $idln=0; $ln=0;
    foreach $x (@wfDetails) {
      $ln=$ln+1;
      if( $x =~ /\bitems\b/ )  {  $flag = 1; }
      if( $flag eq 1 && $x =~ /\bitems\b/) { $flag=2; }
      if($flag eq 2 && $x =~ /\bdatabasesid\b/) { $idln=$ln; }
      if( ($x =~ /\bvalue\b/) && ($ln eq ($idln+1)) ) {
            my @rpt=split(':',$x);
            $repAppName=$rpt[1];
            $repAppName=~ s/,$//;
            $repAppName=~ s/\"//g;
            $repAppName=~ s/^\s+|\s+$//g;
            last;
      }
    }
    if($repAppName eq "") { die "ERROR: there are no existing apps to reprovision \n"; }

    my @repAppDet=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application?filter=appname:==$repAppName`;
    #print "@repAppDet \n";
    foreach $x (@repAppDet) {
      if($x =~ /\bid\b/) {
        my @idt=split(':',$x);
        $repAppID=$idt[1];
        $repAppID=~ s/,$//;
        $repAppID=~ s/\"//g;
        $repAppID=~ s/^\s+|\s+$//g;
        last;
      }
    }
    if($repAppID eq "") { die "ERROR: not able to get reprovision app - $repAppName - id \n"; }

    $wfItems= (substr $wfItems,0,length($wfItems)-3) . ',{"name":"reprovision","items":[{"name":"app","value":"'.$repAppID.'"}]}' . ']}]';
  }
  #print "$wfItems \n";

  my @runWf;
  if($subtype eq "directmount") {
    @runWf=`curl -XPOST -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{
        "operation":"run",
        "update": { "id": "$wfid", "name": "", $scheduleDetails, $wfProps, $wfItems }
      }' https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  }
  if($subtype eq "liveclone") {
    @runWf=`curl -XPOST -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{
        "operation":"run",
        "params":[{"key":"norefreshliveclone","value":"$reflive"},{"key":"nocreatevirtualclone","value":"$provlive"}],
        "update": { "id": "$wfid", "name": "", $scheduleDetails, $wfProps, $wfItems }
      }' https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  }
  #print "@runWf \n";

  if(@runWf == 0) {
    print "Workflow submitted successfully\n";
    sleep(15);
    $wfCurrStat=getWorkflowCurrentStatus($sessionid,$AGMip,$appid,$wfid);
    print "Workflow current status: $wfCurrStat \n";
    if($wfCurrStat eq "RUNNING") {
      $wfJob=getWorkflowCurrentJob($sessionid,$AGMip,$appid,$wfid);
      print "Workflow current job is: $wfJob \n";
    }
  }
  else {
    print "failed to submit workflow. \n $runWf[2]\n";
  }

  #wait if wait option specified
  if( ($statuswait eq "yes") && ($wfCurrStat eq "RUNNING") ) {
    while ($wfCurrStat eq "RUNNING") {
      $wfJob=getWorkflowCurrentJob($sessionid,$AGMip,$appid,$wfid);
      waitForJob($sessionid,$AGMip,$wfJob);
      sleep(10);
      $wfCurrStat=getWorkflowCurrentStatus($sessionid,$AGMip,$appid,$wfid);
    }
  }

} #end of function - runwf
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# getWorkflowCurrentStatus($sessionid,$AGMip,$appid,$workflowid)
#------------------------------------------------------------------------------------------------------------------------
sub getWorkflowCurrentStatus {
  my ($sessionid,$AGMip,$appid,$wfid) = @_;
  @wfDetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  #print "@wfDetails \n";

  #get workflow current details
  $flag=0; $flagc=0; $flagp=0; $flagn=0; $wfCurrStat="";
  foreach $x (@wfDetails) {
    if($x =~ /\bstatus\b/) { $flag=1;}
    if(($flag eq 1) && ($x =~ /\bcurrent\b/) ) { $flagc=1; $flagp=0; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bprev\b/) ) { $flagc=0; $flagp=1; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bnext\b/) ) { $flagc=0; $flagp=0; $flagn=1; }
    if(($flagc eq 1) && ($flagc eq 1) && ($x =~ /\bstatus\b/)) {
      my @stt=split(':',$x);
      $wfCurrStat=$stt[1];
      $wfCurrStat=~ s/,$//;
      $wfCurrStat=~ s/\"//g;
      $wfCurrStat=~ s/^\s+|\s+$//g;
      #print "Workflow current status: $wfCurrStat";
      last;
    }
  }
  return $wfCurrStat;
} #end of function - getWorkflowCurrentStatus
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# getWorkflowCurrentJob($sessionid,$AGMip,$appid,$workflowid)
#------------------------------------------------------------------------------------------------------------------------
sub getWorkflowCurrentJob {
  my ($sessionid,$AGMip,$appid,$wfid) = @_;
  @wfDetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  #print "@wfDetails \n";

  #get workflow current details
  $flag=0; $flagc=0; $flagp=0; $flagn=0; $wfJobTag="";
  foreach $x (@wfDetails) {
    if($x =~ /\bstatus\b/) { $flag=1;}
    if(($flag eq 1) && ($x =~ /\bcurrent\b/) ) { $flagc=1; $flagp=0; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bprev\b/) ) { $flagc=0; $flagp=1; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bnext\b/) ) { $flagc=0; $flagp=0; $flagn=1; }
    if(($flagc eq 1) && ($flagc eq 1) && ($x =~ /\bjobtag\b/)) {
      my @jtt=split(':',$x);
      $wfJobTag=$jtt[1];
      $wfJobTag=~ s/,$//;
      $wfJobTag=~ s/\"//g;
      $wfJobTag=~ s/^\s+|\s+$//g;
      #print "Workflow current jobtag: $wfJobTag\n";
      last;
    }
  }

  my @jobs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/jobstatus?filter=jobtag:==$wfJobTag&filter=status:=="running"`;
  #print "@jobs \n";
  foreach $x (@jobs) {
    if( $x =~ /\bjobname\b/ )  {
      my @pl=split(':',$x);
      $runningJob=$pl[1];
      $runningJob=~ s/,$//;
      $runningJob=~ s/\"//g;
      $runningJob=~ s/^\s+|\s+$//g;
      #print "Workflow current running job: $runningJob \n";
      last;
    }
  }
  return $runningJob;
} #end of function - getWorkflowCurrentJob
#------------------------------------------------------------------------------------------------------------------------

#------------------------------------------------------------------------------------------------------------------------
# waitForJob($sessionid,$AGMip,$jobName)
#------------------------------------------------------------------------------------------------------------------------
sub waitForJob {
  my ($sessionid,$AGMip,$jobName) = @_;
  do{
    my @jobStat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/jobstatus?filter=jobname:==$jobName"`;
    #print "@jobStat \n";
    $job_status="";
    foreach my $x (@jobStat) {
      if($x =~ /\bstatus\b/) {
        my @jtt=split(':',"$x");
        $job_status=$jtt[1];
        $job_status=~ s/,$//;
        $job_status=~ s/\"//g;
        $job_status=~ s/^\s+|\s+$//g;
        last;
      }
    }

    if($job_status eq "running") {
      print "$jobName running...\n"; sleep(60);
    }

  }while( ($job_status eq "running") || ($job_status eq "waiting") );
  print "$jobName - $job_status \n";
} #end of function - waitForJob
#------------------------------------------------------------------------------------------------------------------------
