#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#

set -x
DBTYPE=$1 #ASM/FILESYSTEM
oracleHome=$2
backupLocation=$3
ouser=$4
guser=$5
standalone=$6
ctrlDG=$7
archmnt=$8
tstamp=$9


if [ "$DBTYPE" = "ASM" ]; then
   /act/act_scripts/asmrestore/ASMSwitchRestore.sh "$oracleHome" "$backupLocation" "$ouser" "$guser" "$standalone" "$ctrlDG" "$archmnt" "$tstamp" 
   if [ "$?" -gt 0 ]; then
      echo "ERRORMSG: Failed to Switch database, please check the logs for details!"
      exit 1
   fi
else
   echo "Check the parameters passed."
   exit 1
fi
