alter session set container=&1;
begin
  execute immediate 'create temporary tablespace TEMP_ACTIFIO tempfile ' || '''&2'''|| ' size 100M'; 
  execute immediate 'alter database default temporary tablespace TEMP_ACTIFIO'; 
  for rec in (select distinct tablespace_name from dba_tablespaces where contents='TEMPORARY' and tablespace_name not in ('TEMP_ACTIFIO')) loop
  execute immediate 'drop tablespace '||rec.TABLESPACE_NAME|| ' including contents and datafiles';
  execute immediate 'create temporary tablespace '||rec.TABLESPACE_NAME|| ' tempfile '  || '''&2''' || ' size 5G';
  execute immediate 'alter database default temporary tablespace '||rec.TABLESPACE_NAME; 
  end loop;
  execute immediate 'drop tablespace TEMP_ACTIFIO including contents and datafiles';
end;
/
--exit;
