#!/bin/bash
set -x

ksname=$1

echo "key space name is $ksname"

conffile=/act/scripts/act_Cassandra_src.conf

source /act/scripts/act_Cassandra_src.conf

export DATABASE_DIR
export RECOVERY_FILE_DIR
export CASSANDRA_HOME
export KEYSPACE_NAME
export CLUSTER_NODE_LIST
export TABLE_NAME
echo $CASSANDRA_HOME
echo $RECOVERY_FILE_DIR

scl enable python27 - << EOF
$CASSANDRA_HOME/bin/cqlsh -e "describe keyspace $ksname;" >$RECOVERY_FILE_DIR"/"$ksname"_schema.cql"
EOF

cat $RECOVERY_FILE_DIR"/"$ksname"_schema.cql"

