#!/bin/sh

sessionExists=`iscsiadm -m session | grep -w $SkyIP:3260`
if [ -z "$sessionExists" ]; then
  targetIQN=`iscsiadm -m discovery -t st -p $SkyIP:3260 2> /dev/null | tail -n 1 | awk '{print $NF}'`
  iscsiadm -m node -T $targetIQN -p $SkyIP:3260 -l
  retval=$?
  if [ $retval -ne 0 ]; then
    if [ $retval -eq 15 ]; then
     echo "*** Session Already Exists****"
     exit
    fi
    echo "*** ERROR: Iscsi Login to $SkyIP has Failed************"
    exit $retval
  fi
fi
