/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2012 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getOracleSessionInfo.sql
 *
 * Description:   get Oracle session info give os process id
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE
select s.SID || ',' || s.SERIAL# from V$PROCESS p, V$SESSION s WHERE p.ADDR = s.PADDR and p.SPID ='&1';
exit;

