/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2012 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getRunningRmanSessionPid.sql
 *
 * Description:   get os process id for current running RMAN session
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE
select p.spid from v$process p, v$session s where p.addr=s.paddr and s.sid in (select sid from v$rman_status where command_id like 'ACT_%' and status = 'RUNNING');
exit;
