#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set -x

MAXDBCONFIG="/act/scripts/act_MaxDB_src.conf"

if [ -z $dumpthreadcount ]; then
  dumpthreadcount=2
fi

source /act/act_scripts/maxdb/automation/Backup/dbHelper.sh
echo "Validate if Db has MaxBackupMedia>=dumpthreadcount *********"
validateDumpThreadCount
echo "DumpThreadCount Validation Successfull"

echo -e "# MaxDB config " > $MAXDBCONFIG

if [ -z $LOG_BKP_LOC ]; then
  LOGBKPLOC=$LogBackupFS
else
  LOGBKPLOC=$LOG_BKP_LOC
fi

if [ -z $DUMPSCHEDULE ]; then
  DUMPSCHEDULE="FFFFFFF"
fi

#Creating config file with values.

echo -e "OSUSER='$OSUSER'" >> $MAXDBCONFIG
echo -e "SRC_MAXDB_DBMCLI_PATH='$SRC_MAXDB_DBMCLI_PATH'" >> $MAXDBCONFIG
echo -e "SRC_DBNAME_KEY_PREFIX='$SRC_DBNAME_KEY_PREFIX'" >> $MAXDBCONFIG
echo -e "dumpthreadcount='$dumpthreadcount'" >> $MAXDBCONFIG
echo -e "DUMPSCHEDULE='$DUMPSCHEDULE'" >> $MAXDBCONFIG
echo -e "LOG_BKP_LOC='$LOGBKPLOC'" >> $MAXDBCONFIG
echo -e "SRC_DBNAME='$SRC_DBNAME'" >> $MAXDBCONFIG
echo -e "ACTIFIO_DISK_LOC='$MAXDBBACKUPPATH'" >> $MAXDBCONFIG
echo -e "SkyIP='$SkyIP'" >> $MAXDBCONFIG
echo -e "ProfileName='$ProfileName'" >> $MAXDBCONFIG
echo -e "SRC_HOSTNAME='$SRC_HOSTNAME'" >> $MAXDBCONFIG
chmod 755 $MAXDBCONFIG
