#!/bin/sh
set +x
PWDS=/act/scripts
conffile=$PWDS/act_Sybase_logbackup.conf

if [ -z "$SRC_USER_PASSWD" ]; then
  SRC_USER_PASSWD=`su - $OSUSER -c "/sybase/"$SRC_SERVER_NAME"/dba/bin/dbbp MaGiCpW"`
  if [ -z "$SRC_USER_PASSWD" ]; then
    echo " Error : ISQL Password cannot be empty."
    exit 1
  fi
fi

if [ -f $conffile ]; then
 source $conffile
else
 echo "Configuration file does not exist.."
 exit 1
fi
set -x
tmp_loc=$LOGBKPLOC
tname=$1

if [ -z $LOGBKPLOC ]; then
 exit 0
fi
# Get all the db list and dump transactions when "ALLDB" is specified


if [ "$SRC_DBNAME" = "" ] || [ "$SRC_DBNAME" = "ALLDB" ] || [ "$SRC_DBNAME" = "ALL" ]; then
query="select name from master..sysdatabases where name not in ('master','model','pubs2','pubs3','sybmgmtdb','sybpcidb','sybsystemdb','sybsystemprocs','tempdb','saptempdb','sapsatempdb','sybsecurity','saptools','scbtools')"
set +x
su - $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X -n -b -o $tmp_loc/db_names_log.txt" <<EOF
set nocount on
go
$query
go
quit
EOF
set -x
#sed -i 1,2d $tmp_loc/db_names_log.txt
db_list=''
while read line
do
if [ -z $tname ]; then
tname=`date +%Y%m%d%H%M%S`
fi
filename=$LOGBKPLOC/$line'_'$tname.dat
set +x
su - $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X --retserverror"<<EOF
dump transaction $line to "$filename"
go
EOF
set -x
done < $tmp_loc/db_names_log.txt
else

echo "else"
for i in $(echo $SRC_DBNAME | sed "s/,/ /g")
do
set +x
db_name=`su - $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X -n -b" <<EOF
set nocount on
select name from master..sysdatabases where name = '$i'
go
EOF`
set -x
#db_name=`echo $db_name |awk -F " " '{print $2}'`
echo dbanme:$db_name
if [ -z $tname ]; then
tname=`date +%Y%m%d%H%M%S`
fi
filename=$LOGBKPLOC/$i'_'$tname.dat
if [ ! -z $db_name ]; then
set +x
su - $OSUSER -c "$SRC_SYBASE_SQLD/bin/isql -U$SRC_BACKUP_USER -P$SRC_USER_PASSWD -S$SRC_SERVER_NAME -X"<<EOF
dump transaction $i to "$filename"
go
EOF
set -x
#echo "$filename > $manifestloc/$i.txt'"
fi
done

fi
