#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#
set +x
SYBASEIQCONFIG="/act/scripts/act_SybaseIQ_Src.conf"
if [ -z "$SRC_USER_PASSWD" ]; then
  echo " Error : DBISQL Password cannot be empty."
  exit 1
fi

set -x

#Creating config file with values.
echo -e "# sybaseiq config " > $SYBASEIQCONFIG

if [ -z "$DUMPSCHEDULE" ]
then
  echo -e "DUMPSCHEDULE=FFFFFFF" >> $SYBASEIQCONFIG
else
  echo -e "DUMPSCHEDULE='$DUMPSCHEDULE'" >> $SYBASEIQCONFIG
fi

echo -e "OSUSER='$OSUSER'" >> $SYBASEIQCONFIG
echo -e "SRC_SYBASEIQ_SQLD='$SRC_SYBASEIQ_SQLD'" >> $SYBASEIQCONFIG
echo -e "SRC_BACKUP_USER='$SRC_BACKUP_USER'" >> $SYBASEIQCONFIG
echo -e "SRC_DBNAME='$SRC_DBNAME'" >> $SYBASEIQCONFIG
echo -e "SRC_BACKUP_LOCATION='$SYBASEIQBACKUPPATH'" >> $SYBASEIQCONFIG
echo -e "SkyIP='$SkyIP'" >> $SYBASEIQCONFIG
echo -e "ProfileName='$ProfileName'" >> $SYBASEIQCONFIG
echo -e "SRC_HOSTNAME='$SRC_HOSTNAME'" >> $SYBASEIQCONFIG
chmod 755 $SYBASEIQCONFIG
