#!/bin/sh

#Prepare env
for ARGUMENT in "$@"
do
   ARGUMENT="${ARGUMENT%\"}"
   ARGUMENT="${ARGUMENT#\"}"
   argLft=`echo $ARGUMENT|cut -d= -f1`
   argRit=`echo $ARGUMENT|cut -d= -f2`
   export "$argLft=$argRit"
done

if [ $# -lt 5 ]; then
  echo "ERRORMSG: not provided enough arguments"
  echo -e "Usage:\n/act/custom_apps/postgresql/dump/ACT_POSTGRESQL_dumprestore_newTarget.sh OSUSER=<postgres_osuser> BASEDIR=<postgres_home> PORT=<postgres_port> DB_LIST=<comma seperated db list> DUMPBKPLOC=<mountpoint name> [ DBUSER=<db_user> DBPASSWD=<db_password> ] [ SOCKET_DIR=<SOCKET_DIR> ]"
  exit 1
fi

echo "INFOMSG: ********* predump-restore **********"
/act/custom_apps/postgresql/dump/ACT_POSTGRESQL_predumprestore.sh
if [ $? -ne 0 ];then
  echo "ERRORMSG: Fail to prepare new target for dump restore"
  exit 1
fi

echo ""
echo ""
echo ""
sleep 3

echo "INFOMSG: ********* dump-restore **********"
/act/custom_apps/postgresql/dump/ACT_POSTGRESQL_dumprestore.sh
if [ $? -ne 0 ];then
  echo "ERRORMSG: Fail to restore the database"
  exit 1
fi
