#!/bin/sh

set -x
OSUSER=$OSUSER
PG_HOME=$BASEDIR
DBUSER=$DBUSER
set +x
DBPASSWD="$DBPASSWORD"
set -x
PORT=$PORT
PG_DATA=$SRC_DATADIR
IS_SLAVE=$ISSLAVE
VERSION=$VERSION
SOCKET_DIR=$SOCKET_DIR

BEGIN_TIME=$BEGIN_TIME
UNTIL_TIME=$UNTIL_TIME
LOG_BKP_MNTPT=$LOG_BKP_MNTPT

ACT_JOBNAME=$JOBID

if [ -z "$SOCKET_DIR" ]; then
  SOCKET_DIR=`grep "PORTNO=\"$PORT" /act/custom_apps/POSTGRESQL.xml | awk -F" SOCKET_DIR=" '{print $2}' | awk '{print $1}' | sed 's/"//g'`
fi

#Get common functions
. /act/custom_apps/postgresql/act_postgresql_common_functions.sh

#Validate env
isVarNull OSUSER $OSUSER
isVarNull PG_HOME $PG_HOME
isVarNull PORT $PORT
isVarNull PG_DATA $PG_DATA
#isVarNull VERSION $VERSION
#isVarNull IS_SLAVE $IS_SLAVE
#isVarNull DBUSER $DBUSER

if [ ! -z "$UNTIL_TIME" ]; then
  isVarNull LOG_BKP_MNTPT $LOG_BKP_MNTPT
  if [ ! -d "$LOG_BKP_MNTPT" ]; then
    echo "ERRORMSG: $LOG_BKP_MNTPT is not a directory"
    exit 1
  fi
fi

exit 0
