#!/bin/bash
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# ==============================================================================#


set -x

DATE=`date`
echo "$DATE"

globalpath=`echo $DIR_INSTANCE`
globalpath=`dirname $globalpath`
globalinipath=$globalpath/SYS/global/hdb/custom/config/global.ini


BACKINT_LOG_PAR_FILE=/act/custom_apps/saphana/sapbackint/actifio_backint_log.par
LOGBACKUPPATH=`grep -iw ^basepath_logbackup $globalinipath | cut -d"=" -f2 | sed -e 's/^[ \t]*//'`
LGBACKUPPATH="DB_BACKUP_PATH="$LOGBACKUPPATH
echo "export $LGBACKUPPATH" > /act/custom_apps/saphana/sapbackint/actifio_backint_log.par
echo "export BS=10M" >> /act/custom_apps/saphana/sapbackint/actifio_backint_log.par

exit 0

