#!/bin/sh

set -x

source /act/scripts/act_restore_Cassandra.conf

export CASSANDRA_PATH
export DATABASE_DIR
export RECOVERY_FILE_DIR
export CASSANDRA_AS_SERVICE
export COMMITLOG_DIR
export KEYSPACE_NAME
export TABLE_NAME
export CLUSTER_NODE_LIST

restore_data() {
        echo "Restoring snapshot data: $KEYSPACE_NAME"
        for i in $(echo $KEYSPACE_NAME | sed "s/,/ /g")
         do
          ksname=$i
         (cd $DATABASE_DIR/data/$ksname
         for keyspace1 in `find .  -mindepth 1 -maxdepth 1 -type d`; do
                        echo "Restoring: $keyspace1"
                        for snapshot1 in `find $keyspace1 -mindepth 2 -maxdepth 2 -type d | sort -nr | head -1`; do
                                echo "snapshot is $snapshot1"
                                if [ "x$snapshot1" != "x" ]; then
                                   foundsnap=true
                                   realsnap=$snapshot1
                                   realks=$keyspace1
                                   stabid=`echo "$snapshot1" | sed 's/^.\{2\}//g' | cut -d"-" -f1`
                                fi
                     if [ ! -z "$stabid" ]; then
                     for keyspacein in `find . -mindepth 1 -maxdepth 1 -type d`; do
                          inkid=`echo "$keyspacein" | sed 's/^.\{2\}//g' | cut -d"-" -f1`
                          if [ "x$inkid" = "x$stabid" ]; then
                             cp $realsnap/*.db $keyspacein
                             chmod -R 777 $keyspacein/
                             chmod -R 777 $keyspacein
                          fi
                      done
                     fi
                                # check_for_errors
          done
           stabid=""
        done
      
        )
     done
}

restore_data
