#!/bin/sh
# Script to configure iscsi, configure CHAP and start the service.

set +x 
 iscsiadm -m discoverydb -t sendtargets -p $SkyIP:3260 -o delete 2> /dev/null
 
sed -i '/node.session.auth.authmethod =/c\node.session.auth.authmethod = CHAP' /etc/iscsi/iscsid.conf
sed -i '/node.session.auth.username =/c\node.session.auth.username = '"$CHAPUsername"'' /etc/iscsi/iscsid.conf
sed -i '/node.session.auth.password =/c\node.session.auth.password = '"$CHAPPassword"'' /etc/iscsi/iscsid.conf

sed -i '/discovery.sendtargets.auth.authmethod =/c\discovery.sendtargets.auth.authmethod = CHAP' /etc/iscsi/iscsid.conf
sed -i '/discovery.sendtargets.auth.username =/c\discovery.sendtargets.auth.username = '"$CHAPUsername"'' /etc/iscsi/iscsid.conf
sed -i '/discovery.sendtargets.auth.password =/c\discovery.sendtargets.auth.password = '"$CHAPPassword"'' /etc/iscsi/iscsid.conf
set -x
