/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2018 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : getDuplicateCopyFileNumbers.sql
 *
 * Description:   get duplicated image copy file#
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
SET VERIFY OFF
WHENEVER SQLERROR EXIT SQL.SQLCODE
select FILE# from v$datafile_copy
where UPPER(tag) = UPPER('&1') 
and STATUS = 'A'
and FILE# != 0
group by FILE# having count(*) > 1;
exit;

