/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2015 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : logHistoryDays.sql
 *
 * Description:   get number of days of log history available
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select count(1) from (select distinct trunc(FIRST_TIME) from v$loghist);
exit;
