#!/usr/bin/perl

use MIME::Base64;
use Sys::Hostname;
use Storable;
use Socket;
use File::Basename;
use File::Find;
use Cwd;
use Data::Dumper;
use URI::Escape;

my @session;
my %appdetails;
my $appdetails;
my @sourcelist;
my $sourcelist;
my @hostdetails;
my $hostdetails;

my %arghash = @ARGV;
$| = 1;
my $hostname;
my $appname;
my $bkptype;
my $count=0;
my $pwd;
my $detfile;
my $AGMips;
my $userfile;
my @sesdir;
my $AGMip;
my $sesfile;
my $retuser;
#my $appid;
my @app;
my $app;
my $re_code;

die "Usage:actHANADBM\n       --type \n            <agmconfig> \n            <createTemplate> \n            <hostDiscovery> \n            <protectApp> \n            <backup> \n            <listImageDetails> \n            <mount> \n            <unmountdelete> \n            <restore> \n            <runwf> \n" if ( !exists $arghash{'--type'} );
die "Usage:actHANADBM\n       --type \n            <agmconfig> \n            <createTemplate> \n            <hostDiscovery> \n            <protectApp> \n            <backup> \n            <listImageDetails> \n            <mount> \n            <unmountdelete> \n            <restore> \n            <runwf> \n" if ( (exists $arghash{'--help'}) && (!exists $arghash{'--type'}) );

if ( $arghash{'--type'} eq "agmconfig" ) {
    die " Usage: perl actHANADBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM IP>\n" if ( !exists $arghash{'--username'} );
    die " Usage: perl actHANADBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM IP>\n" if ( !exists $arghash{'--password'} );
    die " Usage: perl actHANADBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM IP>\n" if ( !exists $arghash{'--AGM'} );
    die " Usage: perl actHANADBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM IP>\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "agmconfig") );
    my $username=$arghash{'--username'};
    my $password_en=MIME::Base64::encode($arghash{'--password'});
    my $AGMip=$arghash{'--AGM'};

    my %userhash = (username => $username, password => $password_en, AGMip => $AGMip);
    $pwd = cwd();
    #print "dir is " . $pwd;
    $detfile=$pwd . "/" . $AGMip . "_details";
    #print "file is " . $detfile;
    store \%userhash, $detfile;
    print "user details are stored successfully \n";
}

my $hostip;
my $appliancename;
my $diskprefer;

if ( $arghash{'--type'} eq "hostDiscovery" ) {

die "Usage:actHANADBM --type hostDiscovery \n --appliancename <appliance name> \n --hostname <source hostname> \n --hostip <source host ip> \n --stagingDiskpreference <Type of disk for backup: Block|NFS> \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "hostDiscovery") );
   die "Usage:actHANADBM --type hostDiscovery \n --appliancename <appliance name> \n --hostname <source hostname> \n --hostip <source host ip> \n --stagingDiskpreference <Type of disk for backup: Block|NFS> \n --AGM <AGM name|ip> \n" if (( ( !exists $arghash{'--appliancename'} ) || ( !exists $arghash{'--hostname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "hostDiscovery") );

$appliancename=$arghash{'--appliancename'};
$hostname=$arghash{'--hostname'};

if ( exists $arghash{'--hostip'} ) {
  $hostip=$arghash{'--hostip'};
}

$diskprefer=$arghash{'--stagingDiskpreference'};

if ( $diskprefer eq "Block" ) {
$diskprefer=CBT;
}

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n  Usage:actHANADBM --type hostDiscovery \n --appliancename <appliance name> \n --hostname <source hostname> \n --hostip <source host ip> \n --stagingDiskpreference <Type of disk for backup. Block|NFS> \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "hostDiscovery") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

hostDiscovery();
}

my $logbackupenable;
my $logbackupRPO;
my $logbackupretention;
my $templatename;
my $profilename;
my $snappolicyname;
my $snaprpo;
my $onvaultrpo;

if ( $arghash{'--type'} eq "createTemplate" ) {

die "Usage:actHANADBM --type createTemplate \n --appliancename <appliance name> \n --templatename <template name> \n [--snappolicyname <Snapshot policy name>] \n [--snapRPO <snapshot RPO, default 24 hours>] \n --logbackupenable <true|false> \n [--logbackupfrequency <Log Backup frequency RPO in minutes>] \n [--logbackupretention <Log Backup Retention period in Days>] \n [--onVaultPolicyname <onVault policy name>] \n [--onVaultRPO <onVault RPO, default 24 hours>] \n --profileName <profile name> \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "createTemplate") );
die "Usage:actHANADBM --type createTemplate \n --appliancename <appliance name> \n --templatename <template name> \n [--snappolicyname <Snapshot policy name>] \n [--snapRPO <snapshot RPO, default 24 hours>] \n --logbackupenable <true|false> \n [--logbackupfrequency <Log Backup frequency RPO in minutes>] \n [--logbackupretention <Log Backup Retention period in Days>] \n [--onVaultPolicyname <onVault policy name>] \n [--onVaultRPO <onVault RPO, default 24 hours>] \n --profileName <profile name> \n --AGM <AGM name|ip> \n" if ( ( !exists $arghash{'--appliancename'} ) && ( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "createTemplate") );

$appliancename=$arghash{'--appliancename'};
$templatename=$arghash{'--templatename'};
$profilename=$arghash{'--profileName'};

if ( exists $arghash{'--snappolicyname'} ) {
  $snappolicyname=$arghash{'--snappolicyname'};
}
if ( !exists $arghash{'--snappolicyname'} ) {
  $snappolicyname="actsnappolicy";
}
if ( exists $arghash{'--snapRPO'} ) {
  $snaprpo=$arghash{'--snapRPO'};
}
if ( !exists $arghash{'--snapRPO'} ) {
  $snaprpo="24";
}
$logbackupenable=$arghash{'--logbackupenable'};
$logbackupRPO=$arghash{'--logbackupfrequency'};
$logbackupretention=$arghash{'--logbackupretention'};

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n  Usage:actHANADBM --type createTemplate \n --appliancename <appliance name> \n --templatename <template name> \n --snappolicyname <Snapshot policy name> \n --snapRPO <snapshot RPO> \n --logbackupenable <true|false> \n --logbackupfrequency <Log Backup frequency RPO in minutes> \n --logbackupretention <Log Backup Retention period in Days> \n --onVaultPolicyname <onVault policy name> \n --onVaultRPO <onVault RPO> \n --profileName <profile name> \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "createTemplate") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }
createTemplate();
}

my $backuptype;
my $hanasystemkey;
my $hanatenantprefix;
my $forcefulldbdump;
my $dellog;
my $vgsnapreservespace;

if ($arghash{'--type'} eq "protectApp" ) {
   die "Usage:actHANADBM --type protectApp \n --appname <application name> \n --hostname <source hostname> \n --templatename <Template Name> \n --profilename <Profile Name> \n --backupType <CBT|filesystemDump> \n --hanaSystemDbKey <Hana SystemDB HDB userstore Key Name> \n [--hanaTenantDbkeyPrefix <Prefix for Hana Tenant DB Key Name>] \n [--volumegroupreservespace <volume group snap reserve space in percentage: default 20%>] \n [--forcefulldbdump <true|false>] \n [--productionlogretention <production log purging retention in days>] \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "protectApp") );

   die "Usage:actHANADBM --type protectApp \n --appname <application name> \n --hostname <source hostname> \n --templatename <Template Name> \n --profilename <Profile Name> \n --backupType <CBT|filesystemDump> \n --hanaSystemDbKey <Hana SystemDB HDB userstore Key Name> \n [--hanaTenantDbkeyPrefix <Prefix for Hana Tenant DB Key Name>] \n [--volumegroupreservespace <volume group snap reserve space in percentage: default 20%>] \n [--forcefulldbdump <true|false>] \n [--productionlogretention <production log purging retention in days>] \n --AGM <AGM name|ip> \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--hostname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "protectApp") );

$appname=$arghash{'--appname'};
$hostname=$arghash{'--hostname'};
$backuptype=$arghash{'--backupType'};

$hanasystemkey=$arghash{'--hanaSystemDbKey'};

if ( exists $arghash{'--hanaTenantDbkeyPrefix'} ) {
   $hanatenantprefix=$arghash{'--hanaTenantDbkeyPrefix'};
}

if ( !exists $arghash{'--forcefulldbdump'} ) {
$forcefulldbdump="false";
}
if ( exists $arghash{'--forcefulldbdump'} ) {
$forcefulldbdump=$arghash{'--forcefulldbdump'};
}

if ( exists $arghash{'--volumegroupreservespace'} ) {
$vgsnapreservespace=$arghash{'--volumegroupreservespace'};
}

if ( exists $arghash{'--productionlogretention'} ) {
$dellog=$arghash{'--productionlogretention'};
}

$templatename=$arghash{'--templatename'};
$profilename=$arghash{'--profilename'};

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actHANADBM --type protectApp \n --appname <application name> \n --hostname <source hostname> \n --templatename <Template Name> \n --profilename <Profile Name> \n --backupType <CBT|filesystemDump> \n --hanaSystemDbKey <Hana SystemDB HDB userstore Key Name> \n [--hanaTenantDbkeyPrefix <Prefix for Hana Tenant DB Key Name>] \n [--volumegroupreservespace <volume group snap reserve space in percentage: default 20%>] \n [--forcefulldbdump <true|false>] \n [--productionlogretention <production log purging retention in days>] \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "protectApp") ); 
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }
protectApp();
}

if ($arghash{'--type'} eq "listImageDetails" ) {
   die "Usage:actHANADBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "listImageDetails") );
   die "Usage:actHANADBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "listImageDetails") );

$appname=$arghash{'--appname'};
$hostname=$arghash{'--hostname'};

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n  Usage:actHANADBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "listImageDetails") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }
listImageDetails();
}

if($arghash{'--type'} eq "unmountdelete") {
    die "Usage:actHANADBM --type unmountdelete \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "unmountdelete") );
    die "Usage:actHANADBM --type unmountdelete \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--appName'} ) || ( !exists $arghash{'--sourceHost'} ) || ( !exists $arghash{'--targetHost'} )) && ($arghash{'--type'} eq "unmountdelete") );
    $appname=$arghash{'--appName'};
    $image="";
    $targetHost="";
    $AGMip=$arghash{'--AGM'};

    if ( exists $arghash{'--sourceHost'} ) {
        $sourceHost=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--imageName'} ) {
        $image=$arghash{'--imageName'};
    }
    if ( exists $arghash{'--targetHost'} ) {
        $targetHost=$arghash{'--targetHost'};
    }
    if ( exists $arghash{'--targetAppName'} ) {
        $taname=$arghash{'--targetAppName'};
        #$taname =~ s/(.)/\u$1/g;
    }
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "Usage:actHANADBM --type unmountdelete \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "unmountdelete") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

    unmountdelete();
}

#sub wanted {
#    if(/_details$/) {
#        $userfile=$_;
#        $count++;
#    }

# }

$userfile;
sub wanted {
    #my $file_name = $_;
     $file_list = $AGMip . "_details";
    if ( ( -f $file_list ) ) {
        $userfile=$file_list;
     $count++;
     last;
    }
   # $count++;
}

if ($arghash{'--type'} eq "backup" ) {
   die "Usage:actHANADBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--jobpriority <low|medium|high>] \n --AGM <AGM name|ip> \n [--wait <yes|no>] \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "backup") );
    die "Usage:actHANADBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--jobpriority <low|medium|high>] \n --AGM <AGM name|ip> \n [--wait <yes|no>] \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "backup") );

$appname=$arghash{'--appname'};

if ( !exists $arghash{'--hostname'} ) {
        $hostname=hostname;
        $hostname =~ s/(\w+)\..*/\1/;
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $hostname=$arghash{'--hostname'};
    }
    if ( !exists $arghash{'--backuptype'} ) {
        $bkptype="db";
    }
    elsif ( exists $arghash{'--backuptype'} ) {
        $bkptype=$arghash{'--backuptype'};
    }

    if ( exists $arghash{'--jobpriority'} ) {
        $jobpriority=$arghash{'--jobpriority'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

        if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actHANADBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--jobpriority <low|medium|high>] \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "backup") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

backup();
}

#my $scaleoutnodelist;
#my $targetHost;
#my $sourceHost;

if ($arghash{'--type'} eq "mount" ) {
   die "Usage:actHANADBM --type mount \n --appName <Source Database Name or Source File System Mount Point> \n [--image <Image name>] \n --sourceHost <source Host Name> \n --targetHost <Target Host name> \n [--scaleoutnodelist <HANA Scaleout node list seperated by colon>] \n [--mountpoint <mount location '/act/mnt'>] \n [--appawaremount <true|false default: false>] \n [--targetdbuser <Target database SYSTEMDB user store key>] \n [--targetdbsid <Target Database SID] \n [--recoverytime <'yyyy-mm-dd hh24:mi:ss' #in UTC time>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "mount") );
    die "Usage:actHANADBM --type mount \n --appName <Source Database Name or Source File System Mount Point> \n [--image <Image name>] \n --sourceHost <source Host Name> \n --targetHost <Target Host name> \n [--scaleoutnodelist <HANA Scaleout node list seperated by colon>] \n [--mountpoint <mount location '/act/mnt'>] \n [--appawaremount <true|false default: false>] \n [--targetdbuser <Target database SYSTEMDB user store key>] \n [--targetdbsid <Target Database SID] \n [--recoverytime <'yyyy-mm-dd hh24:mi:ss' #in UTC time>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--appName'} ) && ($arghash{'--type'} eq "mount") );
    $appname=$arghash{'--appName'};
    $sourceHost=hostname;
    $sourceHost =~ s/(\w+)\..*/\1/;
    $image="";
    $targetHost=$sourceHost;

    if ( exists $arghash{'--sourceHost'} ) {
        $hostname=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
        $targetHost=$arghash{'--targetHost'};
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( exists $arghash{'--scaleoutnodelist'} ) {
        $scaleoutnodelist=$arghash{'--scaleoutnodelist'};
        $scaleoutnodelist=~s/\:/%3A/g;
    }

    if ( exists $arghash{'--mountpoint'} ) {
        $mountpoint=$arghash{'--mountpoint'};
    }

    if ( exists $arghash{'--appawaremount'} ) {
        $appawaremount=$arghash{'--appawaremount'};
    }
    if ( !exists $arghash{'--appawaremount'} ) {
        $appawaremount="false";
    }
    if ( exists $arghash{'--targetdbuser'} ) {
        $targetdbuser=$arghash{'--targetdbuser'};
    }
    if ( exists $arghash{'--targetdbsid'} ) {
        $targetdbsid=$arghash{'--targetdbsid'};
    }

   if ( exists $arghash{'--recoverytime'} ) {
        $recoverytime=$arghash{'--recoverytime'};
        $recoverytime=parsedate($recoverytime);
    }

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actHANADBM --type mount \n --appName <Source Database Name or Source File System Mount Point> \n [--image <Image name>] \n --sourceHost <source Host Name> \n --targetHost <Target Host name> \n [--scaleoutnodelist <HANA Scaleout node list seperated by colon>] \n [--mountpoint <mount location '/act/mnt'>] \n [--appawaremount <true|false default:false>] \n [--targetdbuser <Target database SYSTEMDB user store key>] \n [--targetdbsid <Target Database SID] \n [--recoverytime <'yyyy-mm-dd hh24:mi:ss' #in UTC time>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "mount") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

 mount();

}

if ($arghash{'--type'} eq "restore" ) {
   die "Usage:actHANADBM --type restore \n --appName <Source Database Name or Source File System Mount Point> \n [--image <Image name>] \n --sourceHost <source Host Name> \n --targetHost <Target Host name> \n [--recoverytime <'yyyy-mm-dd hh24:mi:ss' #in UTC time>] \n [--excludedblist <Exclude DB list name seperated by name>] \n [--includedblist <Include DB list name seperated by comma>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "restore") );
    die "Usage:actHANADBM --type restore \n --appName <Source Database Name or Source File System Mount Point> \n [--image <Image name>] \n --sourceHost <source Host Name> \n --targetHost <Target Host name> \n [--recoverytime <'yyyy-mm-dd hh24:mi:ss' #in UTC time>] \n [--excludedblist <Exclude DB list name seperated by name>] \n [--includedblist <Include DB list name seperated by comma>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--appName'} ) && ($arghash{'--type'} eq "restore") );
    $appname=$arghash{'--appName'};
    $sourceHost=hostname;
    $sourceHost =~ s/(\w+)\..*/\1/;
    $image="";
    $targetHost=$sourceHost;

    if ( exists $arghash{'--sourceHost'} ) {
        $hostname=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
        $targetHost=$arghash{'--targetHost'};
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

    if ( exists $arghash{'--excludedblist'} ) {
        $excludedblist=$arghash{'--excludedblist'};
    }

    if ( exists $arghash{'--includedblist'} ) {
        $includedblist=$arghash{'--includedblist'};
    }

   if ( exists $arghash{'--recoverytime'} ) {
        $recoverytime=$arghash{'--recoverytime'};
        $recoverytime=parsedate($recoverytime);
    }

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actHANADBM --type restore \n --appName <Source Database Name or Source File System Mount Point> \n [--image <Image name>] \n --sourceHost <source Host Name> \n --targetHost <Target Host name> \n [--recoverytime <'yyyy-mm-dd hh24:mi:ss' #in UTC time>] \n [--excludedblist <Exclude DB list name seperated by name>] \n [--includedblist <Include DB list name seperated by comma>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "restore") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

 restore();
}

if($arghash{'--type'} eq "runwf") {
  die "Usage:actHANADBM.pl --type runwf \n --appName <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") );
  die "Usage:actHANADBM.pl --type runwf \n --appName <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") );
  die "Usage:actHANADBM.pl --type runwf \n --appName <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n --AGM <AGM name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--appName'} ) || ( !exists $arghash{'--hostname'} ) || ( !exists $arghash{'--wfname'} ) ) && ($arghash{'--type'} eq "runwf") );

  $subtype="directmount";
  $wfname=$arghash{'--wfname'};
  $dbname=$arghash{'--appName'};
  $hostname=$arghash{'--hostname'};
  $AGMip = $arghash{'--AGM'};
  $reprov=$arghash{'--reprovision'};
  $reflive="";
  $provlive="";

  if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
  }
  if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
  }
  else {
        $statuswait=$arghash{'--wait'};
  }

  runwf();
}

sub getSessionID {

   $pwd = cwd();
    @sesdir = ("$pwd",);
    $count=0;
    File::Find::find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};
      #print "AGM in file " . $AGMips . "\n";
    $detfile=$pwd . "/" . $AGMips . "_details";
   if ($count == 1) {
    $sesfile=$userfile;
  }
   if ($count > 1) {
    $sesfile=$detfile;
  }
  if (!-e $sesfile) {
   die "AGM user details file is missing\n";
  }
   #print "count is " . $count . "\n";
   #print "session file is " . $sesfile . "\n";
    $retuser = retrieve ($sesfile);
    my $username = $retuser -> {username};
    my $password_en = $retuser -> {password};

    my $password_de = MIME::Base64::decode($password_en);
    my $pass_enc = uri_escape($password_de);

my %token=`curl -XPOST --user $username:$pass_enc --tlsv1.2 -k -s https://$AGMips/actifio/session`; 

foreach my $key (%token) { 
if ($key =~ /session_id/) { 
my @session = split(':', $key);
#print "The session id is" . $session[1] . "\n"; 
my $sessionid = $session[1];
return $sessionid;
  }
 }

}

sub mount {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

if ( $appid eq "" ) {
die "could not get appID \n";
}

my $jobclass;
my $backupname;
my $bkpid;
my $mntjobid;

if ($image eq "") {
   $bkpname = getLatestImage();
  # @bkparray = split /:/, $bkpstring;
  # $imageid = $bkparray[0];
  # $bkpname = $bkparray[1];
  # print "image id is " . $imageid ."\n";
   print "image name is " . $bkpname ."\n";
 }
 else {
     $bkpname=$image;
 }

 if ( $bkpname eq "" ) {
     die "could not get latest imagename\n";
    }

my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=backupname:==$bkpname"`;

foreach my $p (@imgdetails) {

#print $p . "\n";

if ($p =~ /\bid\b/) {
my @backup = split(':', $p);
$backupid =  $backup[1];
$backupid =~ s/,$//;
$backupid =~ s/\"//g;
$backupid =~ s/^\s+|\s+$//g;
print "Image ID:  " . $backupid . "\n";
$bkpid = $backupid;
last;
    }

}
print "backup id is " . $bkpid . "\n";

$hostname=$targetHost;
my $thostid=getOHostID();
print "target host id is " . $thostid . "\n";

if ( ($mountpoint ne "") && ($scaleoutnodelist eq "") && ($appawaremount eq "false") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"mountpointperimage","value":"$mountpoint"}],"host":{"id":"$thostid"}}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($mountpoint ne "") && ($scaleoutnodelist eq "") && ($appawaremount eq "true") && ($recoverytime ne "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"mountpointperimage","value":"$mountpoint"}],"host":{"id":"$thostid"},"appaware":"true","recoverytime":"$recoverytime","provisioningoptions":[{"name":"dbsid","value":"$targetdbsid"},{"name":"DBUSER","value":"$targetdbuser"}],"selectedobjects":[{"restorableobject":"$appname"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($mountpoint ne "") && ($scaleoutnodelist eq "") && ($appawaremount eq "true") && ($recoverytime eq "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"mountpointperimage","value":"$mountpoint"}],"host":{"id":"$thostid"},"appaware":"true","provisioningoptions":[{"name":"dbsid","value":"$targetdbsid"},{"name":"DBUSER","value":"$targetdbuser"}],"selectedobjects":[{"restorableobject":"$appname"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
#print "curl -XPOST -k --tlsv1.2 -H Authorization: Actifio " . $sessionid . " -H Content-Type: application/json -d '{restoreoptions:[{name:mountpointperimage,value:" . $mountpoint . "}],host:{id:" . $thostid . "},appaware:true,provisioningoptions:[{name:dbsid,value:" . $targetdbsid . "},{name:DBUSER,value:" . $targetdbuser . "}],selectedobjects:[{restorableobject:" . $appname ."}]}' https://" . $AGMips . "/actifio/backup/" . $bkpid . "/mount \n"; 
}

if ( ($mountpoint ne "") && ($scaleoutnodelist ne "") && ($appawaremount eq "false") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"asmracnodelist","value":"$scaleoutnodelist"},{"name":"mountpointperimage","value":"$mountpoint"}],"host":{"id":"$thostid"}}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($mountpoint ne "") && ($scaleoutnodelist ne "") && ($appawaremount eq "true") && ($recoverytime ne "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"asmracnodelist","value":"$scaleoutnodelist"},{"name":"mountpointperimage","value":"$mountpoint"}],"host":{"id":"$thostid"},"appaware":"true","recoverytime":"$recoverytime","provisioningoptions":[{"name":"dbsid","value":"$targetdbsid"},{"name":"DBUSER","value":"$targetdbuser"}],"selectedobjects":[{"restorableobject":"$appname"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}
if ( ($mountpoint ne "") && ($scaleoutnodelist ne "") && ($appawaremount eq "true") && ($recoverytime eq "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"asmracnodelist","value":"$scaleoutnodelist"},{"name":"mountpointperimage","value":"$mountpoint"}],"host":{"id":"$thostid"},"appaware":"true","provisioningoptions":[{"name":"dbsid","value":"$targetdbsid"},{"name":"DBUSER","value":"$targetdbuser"}],"selectedobjects":[{"restorableobject":"$appname"}]}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

if ( ($mountpoint eq "") && ($scaleoutnodelist ne "") ) {
my @mountdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"asmracnodelist","value":"$scaleoutnodelist"},{"name":"mountpointperimage","value":""}],"host":{"id":"$thostid"}}' https://$AGMips/actifio/backup/$bkpid/mount 2>/dev/null`;
}

#print @mountdet . "\n";

if ( @mountdet == 0 ) {
sleep(15);
my @mountjob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=appname:==$appname&filter=status:==running&filter=jobclasscode:==5"`;

foreach my $j (@mountjob) {
if ($j =~ /jobname/) {
my @mntj = split(':', $j);
my $mntjid =  $mntj[1];
$mntjid =~ s/,$//;
$mntjid =~ s/\"//g;
$mntjid =~ s/^\s+|\s+$//g;
$mntjobid = $mntjid;
print "Mount JobName:     " . $mntjobid . "\n";
last;
}
 }

#print "Mount Job " . $mntjobid . " submitted Successfully\n";
}

if ( $mntjobid ne "" ) {
print "Mount Job " . $mntjobid . " submitted Successfully\n";
}

if ( $mntjobid eq "" ) {
return -1;
die "Mount Job submission failed \n";
}

my $job_stat;
my @jobstatarray;

if ( ( @mountdet == 0 ) && ($statuswait eq "yes") ) {

        $job_stat = jobStatus($mntjobid);

         @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( ( $job_error ne "10016" ) && ( $job_status eq "running" ) )  {
            sleep(60);
            $job_stat = jobStatus($mntjobid);
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
            print $job_status . "\n";
        }

        if ( $job_error eq "10016" ) {

            my @jobhiststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobhistory?filter=jobname:==$mntjobid"`;

foreach my $j (@jobhiststat) {
if ($j =~ /\bstatus\b/) {
#if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Mount Job:     " . $mntjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobhiststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Mount Job:     " . $mntjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }
}
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            return -1;
            print $job_errmsg . "\n";
            print "Mount Job " . $mntjobid . " is " . $job_status . "\n";
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Mount Job " . $mntjobid . " is " . $job_status . "\n";
        }
         exit $re_code;
    }

}

sub restore {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

if ( $appid eq "" ) {
die "could not get appID \n";
}

my $jobclass;
my $backupname;
my $bkpid;
my $mntjobid;

if ($image eq "") {
   $bkpname = getLatestImage();
  # @bkparray = split /:/, $bkpstring;
  # $imageid = $bkparray[0];
  # $bkpname = $bkparray[1];
  # print "image id is " . $imageid ."\n";
   print "image name is " . $bkpname ."\n";
 }
 else {
     $bkpname=$image;
 }

 if ( $bkpname eq "" ) {
     die "could not get latest imagename\n";
    }

my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=backupname:==$bkpname"`;

foreach my $p (@imgdetails) {

#print $p . "\n";

if ($p =~ /\bid\b/) {
my @backup = split(':', $p);
$backupid =  $backup[1];
$backupid =~ s/,$//;
$backupid =~ s/\"//g;
$backupid =~ s/^\s+|\s+$//g;
print "Image ID:  " . $backupid . "\n";
$bkpid = $backupid;
last;
    }

}
print "backup id is " . $bkpid . "\n";

$hostname=$targetHost;
my $hostid=getHostID();
print "host id is " . $hostid . "\n";

if ($recoverytime ne "") {

print "recovery time in echo format " . $recoverytime . "\n";

if ( ($excludedblist ne "") && ($includedblist eq "") ) {
my @restoredet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"excludedblist","value":"$excludedblist"}],"restoreobjectmappings":[],"nfsOptions":{"client":[],"server":[]},"systemstateoptions":[],"recoverytime":"$recoverytime"}' https://$AGMips/actifio/backup/$bkpid/restore 2>/dev/null`;
}

if ( ($excludedblist eq "") && ($includedblist ne "") ) {
my @restoredet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"includedblist","value":"$includedblist"}],"restoreobjectmappings":[],"nfsOptions":{"client":[],"server":[]},"systemstateoptions":[],"recoverytime":"$recoverytime"}' https://$AGMips/actifio/backup/$bkpid/restore 2>/dev/null`;
}

if ( ($excludedblist eq "") && ($includedblist eq "") ) {
my @restoredet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreobjectmappings":[],"nfsOptions":{"client":[],"server":[]},"systemstateoptions":[],"recoverytime":"$recoverytime"}' https://$AGMips/actifio/backup/$bkpid/restore 2>/dev/null`;
}
}
if ($recoverytime eq "") {
if ( ($excludedblist ne "") && ($includedblist eq "") ) {
my @restoredet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"excludedblist","value":"$excludedblist"}],"restoreobjectmappings":[],"nfsOptions":{"client":[],"server":[]},"systemstateoptions":[]}' https://$AGMips/actifio/backup/$bkpid/restore 2>/dev/null`;
}

if ( ($excludedblist eq "") && ($includedblist ne "") ) {
my @restoredet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreoptions":[{"name":"includedblist","value":"$includedblist"}],"restoreobjectmappings":[],"nfsOptions":{"client":[],"server":[]},"systemstateoptions":[]}' https://$AGMips/actifio/backup/$bkpid/restore 2>/dev/null`;
}

if ( ($excludedblist eq "") && ($includedblist eq "") ) {
my @restoredet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"restoreobjectmappings":[],"nfsOptions":{"client":[],"server":[]},"systemstateoptions":[]}' https://$AGMips/actifio/backup/$bkpid/restore 2>/dev/null`;
}
}
print @restoredet . "\n";

if ( @restoredet == 0 ) {
sleep(15);
my @restjob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=appname:==$appname&filter=status:==running&filter=jobclass:==restore"`;

foreach my $j (@restjob) {
if ($j =~ /jobname/) {
my @mntj = split(':', $j);
my $mntjid =  $mntj[1];
$mntjid =~ s/,$//;
$mntjid =~ s/\"//g;
$mntjid =~ s/^\s+|\s+$//g;
$mntjobid = $mntjid;
print "Restore JobName:     " . $mntjobid . "\n";
last;
}
 }

print "Restore Job " . $mntjobid . " submitted Successfully\n";
}

if ( @restoredet > 0 ) {
return -1;
die "Mount Job submission failed\n";
}
my $job_stat;
my @jobstatarray;

if ( ( @restoredet == 0 ) && ($statuswait eq "yes") ) {

        $job_stat = jobStatus($mntjobid);

         @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( ( $job_error ne "10016" ) && ( $job_status eq "running" ) )  {
            sleep(60);
            $job_stat = jobStatus($mntjobid);
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
            print $job_status . "\n";
        }

        if ( $job_error eq "10016" ) {

            my @jobhiststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobhistory?filter=jobname:==$mntjobid"`;

foreach my $j (@jobhiststat) {
if ($j =~ /\bstatus\b/) {
#if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Restore Job:     " . $mntjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobhiststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Restore Job:     " . $mntjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }
}
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            print "Restore Job " . $mntjobid . " is " . $job_status . "\n";
           return -1; 
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Restore Job " . $mntjobid . " is " . $job_status . "\n";
        }
         exit $re_code;
    }

}

sub getLatestImage {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

print "\n";

if ($imagetype eq "") {
   $imagetype="snapshot";
}

my $jobclass;
my $backupname;
my $beginpit;
my $endpit;
my $bpit;
my $epit;

print "image type is " . $imagetype . "\n";
my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==$imagetype&filter=hostname:==$hostname"`;

foreach my $p (@imgdetails) {

#print $p;

if ($p =~ /\bbackupname\b/) {
my @backup = split(':', $p);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Image Name:  " . $backupname . "\n";
return $backupname;
    }
  }
}

}

sub getHostID {

my @arr;
my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

print "host name " . $hostname . "\n";
my @hostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;
#my @hostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/host?filter=hostname:==$hostname"`;

foreach my $k (@hostdetails) {
#print $k;
if ($k =~ /\bhost\b/) {
$f = 1;
}

if ($f == 1) {
push(@arr, $k);
}

if ($k =~ /\bdbauthentication\b/) {
       # $f = 0;
last;
}
#continue;
#last;
}

foreach my $p (@arr) {
#foreach my $p (@hostdetails) {
#print $p . "\n";

if ($p =~ /\bid\b/) {
my @hosti = split(':', $p);
my $hostid =  $hosti[1];
$hostid =~ s/,$//;
$hostid =~ s/\"//g;
$hostid =~ s/^\s+|\s+$//g;
print "Host ID:     " . $hostid . "\n";
return $hostid;
last;
}
}
}

sub getApplianceID {

my @arr;
my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}
my $applID;
print "Appliance name " . $appliancename . "\n";
my @appliancedetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/cluster?filter=name:==$appliancename"`;
foreach my $k (@appliancedetails) {
if ($k =~ /\bclusterid\b/) {
   my @clua = split(':', $k);
   my $appliaID =  $clua[1];
   $appliaID =~ s/,$//;
   $appliaID =~ s/\"//g;
   $appliaID =~ s/^\s+|\s+$//g;
   $applID = $appliaID;
#print "in appl id " . $applID . "\n";
return $applID;
last;
}
}
}

sub getOHostID {

my @arr;
my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}
my $hostID;
print "Appliance name " . $appliancename . "\n";
my @ohostdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/host?filter=hostname:==$hostname"`;
foreach my $k (@ohostdetails) {
#print $k;
if ($k =~ /\bid\b/) {
   my @clua = split(':', $k);
   my $hostaID =  $clua[1];
   $hostaID =~ s/,$//;
   $hostaID =~ s/\"//g;
   $hostaID =~ s/^\s+|\s+$//g;
   $hostID = $hostaID;
   print "in host id " . $hostID . "\n";
return $hostID;
last;
}
}
}

sub getAppID {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

#print "host name " . $hostname . "\n";
#print "pp name is " . $appname . "\n";
my $taappid;
my @arr;

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;

#print "curl -XGET -k -s --tlsv1.2 -H Authorization: Actifio " . $sessionid . "https://" . $AGMips . "/actifio/application?filter=appname:==" . $appname . "&filter=hostname:==" . $hostname . "\n";

foreach my $k (@appdetails) {
#print $k;
push(@arr, $k);
if ($k =~ /},/) {
last;
 }
}
#print @arr;
my $flag;
foreach my $p (@arr) {
#print $p . "\n";
$flag = 0;
if ( ($p =~ /$appname/) && ($p =~ /$hostname/) ) {
$flag = 1;
}

if (defined($flag) & $p =~ /id/) {
my @appi = split(':', $p);
$taappid =  $appi[1];
print "App ID:     " . $taappid . "\n";
return $taappid;
}
}
}

my $job_status;

sub backup {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}
my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
print "AppID is " . $appid . "\n";
print "\n";
if ( $appid eq "" ) {
die "could not get appID \n";
}

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;

if ( @appdetails < 4 ) {
print "Application Name: " . $appname . " not found\n";
}

my $sltf;
my $sltid;
my $slpf;
my $bkpjobid;
#my $job_status;
my $job_errmsg;

foreach my $k (@appdetails) {
if ($k =~ /slt/) {
$flag=1;
}
if (defined($flag) & $k =~ /name/) {
my @slti = split(':', $k);
my $sltn =  $slti[1];
$sltn =~ s/,$//;
$sltn =~ s/\"//g;
$sltn =~ s/^\s+|\s+$//g;
$sltf = $sltn;
print "slt:     " . $sltn . "\n";
last;
}
 }

foreach my $i (@appdetails) {
if ($i =~ /slt/) {
$iflag=1;
}
if (defined($iflag) & $i =~ /id/) {
my @sltin = split(':', $i);
my $slti =  $sltin[1];
$slti =~ s/,$//;
$slti =~ s/\"//g;
$slti =~ s/^\s+|\s+$//g;
$sltid = $slti;
print "sltID:     " . $sltid . "\n";
last;
}
 }

foreach my $s (@appdetails) {
if ($s =~ /slp/) {
$sflag=1;
}
if (defined($sflag) & $s =~ /name/) {
my @slpi = split(':', $s);
my $slpn =  $slpi[1];
$slpn =~ s/,$//;
$slpn =~ s/\"//g;
$slpn =~ s/^\s+|\s+$//g;
$slpf = $slpn;
print "slp:     " . $slpf . "\n";
last;
}
 }

my $policyid;
my $optype;
my @parr;
my $bkp_job_id;
my @policydet=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" https://$AGMips/actifio/slt/$sltid/policy`;

if ( @policydet < 4 ) {
print "Policy Details for " . $appname . " not found\n";
}

foreach my $p (@policydet) {
if ($p =~ /\@type/) {
$f = 1;
}

if ($f == 1) {
push(@parr, $p);
}

if ($p =~ /\bop\b/) {
        $f = 0;
}
#continue;
#last;
}
foreach my $p (@parr) {
#print $p;
if ($p =~ /id/) {
my @poli = split(':', $p);
my $polid =  $poli[1];
$polid =~ s/,$//;
$polid =~ s/\"//g;
$polid =~ s/^\s+|\s+$//g;
$policyid = $polid;
}
if ($p =~ /\bop\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$optype = $opt;
}
#print "operation type is " . $optype . "\n";
if ($optype eq "snap") {
print "PolicyID:     " . $policyid . "\n";
last;
}
}

print $policyid . "\n";

my @backupdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"policy": {"id": "$policyid"},"backuptype": "$bkptype"}' https://$AGMips/actifio/application/$appid/backup 2>/dev/null`;


#if ( $backlabel ne "" ) {
#my @backupdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"policy": {"id": "$policyid"},"backuptype": "$bkptype","backuplabel":"$backlabel"}' https://$AGMips/actifio/application/$appid/backup 2>/dev/null`;
#}

#print @backupdet . "\n";

if ( @backupdet == 0 ) {
sleep(15);
my @backupjob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=appname:==$appname&filter=hostname:==$hostname&filter=jobclasscode:==1"`;
foreach my $j (@backupjob) {
#print $j . "\n";
if ($j =~ /id/) {
my @bkpji = split(':', $j);
my $bkpjoid =  $bkpji[1];
$bkpjoid =~ s/,$//;
$bkpjoid =~ s/\"//g;
$bkpjoid =~ s/^\s+|\s+$//g;
$bkp_job_id = $bkpjoid;
print "Backup Job Id:     " . $bkp_job_id . "\n";
last;
}
}
foreach my $j (@backupjob) {
if ($j =~ /jobname/) {
my @bkpj = split(':', $j);
my $bkpjid =  $bkpj[1];
$bkpjid =~ s/,$//;
$bkpjid =~ s/\"//g;
$bkpjid =~ s/^\s+|\s+$//g;
$bkpjobid = $bkpjid;
print "Backup JobName:     " . $bkpjobid . "\n";
last;
}
 }


my @jobstata=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=jobname:==$bkpjobid"`;

foreach my $s (@jobstata) {
if ($s =~ /\bstatus\b/) {
#if ($s =~ /status/) {
my @jobst = split(':', $s);
my $jobstatf =  $jobst[1];
$jobstatf =~ s/,$//;
$jobstatf =~ s/\"//g;
$jobstatf =~ s/^\s+|\s+$//g;
$jobstatusf = $jobstatf;
print "Backup Job: " . $bkpjobid . "\t Status: " . $jobstatusf . " submitted\n";
print "\n";
last;
}
 }

#print "job status is " . $jobstatusf . "\n";
#print "job priority input " . $jobpriority . "\n";

my $jobprflag;
if ( ($jobpriority ne "") && ($jobstatusf eq "queued") ) {
   #my @jobbkppri=`curl -XPOST -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/job/$bkpjobid"`;
my @jobbkppri=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"priority":"$jobpriority"}' https://$AGMips/actifio/job/$bkp_job_id  2>/dev/null`;

sleep 5;
#print "priority change " . @jobbkppri . "\n";

foreach my $p (@jobbkppri) {
   if ($p =~ /changerequesttext/) {
my @jobpr = split(':', $p);
my $jobprf =  $jobpr[1];
$jobprf =~ s/,$//;
$jobprf =~ s/\"//g;
$jobprf =~ s/^\s+|\s+$//g;
$jobprflag = $jobprf;
#print "job priority flag inside " . $jobprflag . "\n";
last;
}
   }
if ( $jobprflag == "CHANGEPRIORITY" ) {
printf "Backup job " . $bkpjobid . " priority change request submitted to " . $jobpriority . "\n";
}

}
#print "Backup Job " . $bkpjobid . " submitted Successfully\n";
}

if ( @backupdet > 0 ) {
die "Backup Job submission failed\n";
}
my $job_stat;
my @jobstatarray;

if ( ( @backupdet == 0 ) && ($statuswait eq "yes") ) {
        
        $job_stat = jobStatus($bkpjobid);
        
         @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( ( $job_error ne "10016" ) && ( $job_status eq "running" ) )  {
            sleep(60);
            $job_stat = jobStatus($bkpjobid);
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
            print $job_status . "\n";
        }

        if ( $job_error eq "10016" ) {

            my @jobhiststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobhistory?filter=jobname:==$bkpjobid"`;

foreach my $j (@jobhiststat) {
if ($j =~ /\bstatus\b/) {
#if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobhiststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }
}
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            print "Backup Job " . $bkpjobid . " is " . $job_status . "\n";
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Backup Job " . $bkpjobid . " is " . $job_status . "\n";
        }        
         exit $re_code;
    }

}

my $job_error;
my $jobstatus;
my $joberrc;

sub jobStatus {

$bkpjobid = $_[0];

#my $jobstatus;
#my $joberrc;

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

my @jobststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=jobname:==$bkpjobid"`;

foreach my $j (@jobststat) {
if ($j =~ /\bstatus\b/) {
#if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }

return $jobstatus .":". $joberrc;
}

sub listImageDetails {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

if ( $appid eq "" ) {
die "could not get appID \n";
}

my $jobclass;
my $backupname;
my $beginpit;
my $endpit;
my $bpit;
my $epit;
my $cond;

my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==snapshot&filter=hostname:==$hostname"`;

#my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname"`;

print "Database Name: " . $appname . "\n";
print "Host Name: " . $hostname . "\n";
print "\n";

foreach my $p (@imgdetails) {

#print $p;

#if ( $p =~ /\bjobclass\b/ ) {
#my @jobcl = split(':', $p);
#$jobclass = $jobcl[1];
#$jobclass =~ s/,$//;
#$jobclass =~ s/\"//g;
#$jobclass =~ s/^\s+|\s+$//g;
#print "Job Type:  " . $jobclass . "\n";
# }
#print $p;

if ($p =~ /\bbackupname\b/) {
my @backup = split(':', $p);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Snapshot Image and Recovery Range \n";
#print "Image Type:  " . Snapshot . "\n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($p =~ /beginpit/) {
my @beginp = split(':', $p);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
  }
if ($p =~ /endpit/) {
my @endp = split(':', $p);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));
#print $endpit;
# }

if ( defined($beginpit) && defined($endpit) ) { 
#print "Snapshot Image and Recovery Range \n";
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
else {
if ($p =~ /consistencydate/) {
my @conp = split(':', $p);
$conpd =  $conp[1];
$conpd =~ s/,$//;
$conpd =~ s/\"//g;
$conpd =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$cond = strftime("%Y-%m-%d %H:%M:%S", localtime($conpd/1000/1000));
#print $cond;
# }
if ( defined($beginpit) ) {
print "Conistency Date: '" . $cond . "' \n";
print "\n";
}
}
}
}

my @dedetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==dedup&filter=hostname:==$hostname"`;

foreach my $q (@dedetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Dedup Image and Recovery Range \n";
#print "Image Type:  " . Dedup . "\n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
#print "Dedup Image and Recovery Range \n";
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @livedetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==liveclone&filter=hostname:==$hostname"`;

foreach my $q (@livedetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "LiveClone Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @dasdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==dedupasync&filter=hostname:==$hostname"`;

foreach my $q (@dasdetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "DedupAsync Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @sspdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==StreamSnap&filter=hostname:==$hostname"`;

foreach my $q (@sspdetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "StreamSnap Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

}

sub hostDiscovery {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applianceid=getApplianceID();
print "appliance id is " . $applianceid . "\n";

my @addhost=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"hosttype":"generic","hostname":"$hostname","ipaddress":"$hostip","friendlypath":"$hostname","sources":[{"clusterid":"$applianceid"}],"agents":null}' https://$AGMips/actifio/host/ 2>/dev/null`;

#print @addhost;
sleep (30);

my $hostid=getOHostID;
print "host id is " . $hostid . "\n";

if ( $hostid ne "" ) {

my @updateHost=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: applcation/json" -d '{"id":"$hostid","hostname":"$hostname","ipaddress":"$hostip","diskpref":"$diskprefer"}' https://$AGMips/actifio/host/$hostid?clone=true 2>/dev/null`;

my @adddiscover=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"host":{"id":"$hostid","sources":[{"clusterid":"$applianceid"}]}}' https://$AGMips/actifio/host/discover 2>/dev/null`; 

#print @adddiscover;
return 0;
}
else {
  print "Host " . $hostname . " discovery is failed \n";
return 1;
}
}

sub createTemplate {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applianceid=getApplianceID();
print "appliance id is " . $applianceid . "\n";
if ( $logbackupenable ne "true" ) {
my @createTemplate=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"name":"$templatename","description":"","override":"true","policies":[{"op":"snap","name":"$snappolicyname","iscontinuous":false,"starttime":68400,"endtime":25200,"rpo":"$snaprpo","rpom":"hours","retention":1,"retentionm":"days","priority":"medium","temp-id":"252","options":[{"name":"scriptfinishtimeout","value":"86400","metadata":{"select":false,"constant":false,"min":1,"apponly":false,"max":86400,"name":"scriptfinishtimeout","overridable":true,"alias":"Script Finish Timeout","type":"range","desc":"Script finish timeout","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"scriptunfreezetimeout","value":"86400","metadata":{"select":false,"constant":false,"min":1,"apponly":false,"max":86400,"name":"scriptunfreezetimeout","overridable":true,"alias":"Script Unfreeze Timeout","type":"range","desc":"Script unfreeze timeout","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"scriptfreezetimeout","value":"86400","metadata":{"select":false,"constant":false,"min":1,"apponly":false,"max":86400,"name":"scriptfreezetimeout","overridable":true,"alias":"Script Freeze Timeout","type":"range","desc":"Script freeze timeout","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true}],"scheduling":"windowed","scheduletype":"daily","repeatinterval":"1","exclusiontype":"none","exclusioninterval":"1","exclusion":"none","selection":"none"}]}' https://$AGMips/actifio/slt 2>/dev/null`;
}

#print @createTemplate;

if ( $logbackupenable eq "true" ) {

my @createTemplate=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"name":"$templatename","description":"","override":"true","policies":[{"op":"snap","name":"$snappolicyname","iscontinuous":false,"starttime":68400,"endtime":25200,"rpo":"$snaprpo","rpom":"hours","retention":1,"retentionm":"days","priority":"medium","temp-id":"252","options":[{"name":"scriptfinishtimeout","value":"86400","metadata":{"select":false,"constant":false,"min":1,"apponly":false,"max":86400,"name":"scriptfinishtimeout","overridable":true,"alias":"Script Finish Timeout","type":"range","desc":"Script finish timeout","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"scriptunfreezetimeout","value":"86400","metadata":{"select":false,"constant":false,"min":1,"apponly":false,"max":86400,"name":"scriptunfreezetimeout","overridable":true,"alias":"Script Unfreeze Timeout","type":"range","desc":"Script unfreeze timeout","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"scriptfreezetimeout","value":"86400","metadata":{"select":false,"constant":false,"min":1,"apponly":false,"max":86400,"name":"scriptfreezetimeout","overridable":true,"alias":"Script Freeze Timeout","type":"range","desc":"Script freeze timeout","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"scriptinittimeout","value":"86400","metadata":{"select":false,"constant":false,"min":1,"apponly":false,"max":86400,"name":"scriptinittimeout","overridable":true,"alias":"Script Init Timeout","type":"range","desc":"Script initialization timeout","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"immutabilitydays","value":"1","metadata":{"select":false,"constant":false,"max":36525,"apptype":"*","type":"range","multi":false,"default":"0","min":0,"apponly":false,"name":"immutabilitydays","overridable":true,"alias":"Enforced Retention (days)","desc":"If set, it will be impossible to expire images created with this policy or modify their expiration date until this number of days has passed since its creation.  This value must be equal to or less than the regular retention on the policy","range":true,"value":[{"desc":"","value":0,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"logreplication","value":"false","metadata":{"default":"true","select":true,"constant":false,"apponly":false,"name":"logreplication","overridable":true,"alias":"Replicate Logs (uses StreamSnap technology)","type":"string","value":[{"value":"true","desc":"Yes","isSelected":false},{"value":"false","desc":"No","isSelected":true}],"desc":"Select if you want the database logs to be replicated, enabling for point-in-time recoveries at the remote location. Requires the database to also be replicated","multi":false,"disabled":false},"optionid":"","dirty":true},{"name":"logbackupretention","value":"$logbackupretention","metadata":{"default":"2","select":false,"constant":false,"min":1,"apponly":false,"max":90,"name":"logbackupretention","overridable":true,"alias":"Log Backup Retention Period (in days)","type":"range","desc":"Retain database log backup for the specified period (1 to 90 days). This is required when log backup is enabled","multi":false,"range":true,"value":[{"desc":"","value":1,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"logbackupfreq","value":"$logbackupRPO","metadata":{"default":"60","select":false,"constant":false,"min":15,"apponly":false,"max":1440,"name":"logbackupfreq","overridable":true,"alias":"RPO (minutes)","type":"range","desc":"Frequency for database log backup jobs (in minutes). This value must not exceed database backup frequency","multi":false,"range":true,"value":[{"desc":"","value":15,"isSelected":false}],"disabled":false},"optionid":"","dirty":true},{"name":"logsmart","value":"true","metadata":{"default":"false","select":false,"constant":false,"apponly":false,"name":"logsmart","overridable":true,"alias":"Enable Database Log Backup","type":"boolean","desc":"Select Yes if you want to enable database log backups","multi":false,"bool":true,"value":[{"desc":"No","value":"false","isSelected":false},{"desc":"Yes","value":"true","isSelected":true}],"disabled":false},"optionid":"","dirty":true},{"name":"truncatelog","value":"yes","metadata":{"default":"no","select":true,"constant":false,"apponly":false,"apptype":"SqlInstance,SqlServerWriter,Microsoft Exchange Writer,SharePoint Services Writer,VMBackup,Microsoft Hyper-V VSS Writer,Oracle,ConsistGrp","name":"truncatelog","overridable":true,"alias":"Truncate/Purge Log After Backup","type":"string","value":[{"value":"no","desc":"Do not truncate/purge log after backup","isSelected":false},{"value":"yes","desc":"Truncate/Purge log after backup","isSelected":true}],"desc":"Truncate log after backup for MSSQL/Exchange; Purge log after backup for Oracle","multi":false,"disabled":false},"optionid":"","dirty":true}],"scheduletype":"daily","repeatinterval":"1","exclusiontype":"none","exclusioninterval":"1","exclusion":"none","selection":"none"}]}' https://$AGMips/actifio/slt 2>/dev/null`;

}

my $sltid;

my @getsltid=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/slt?filter=name:==$templatename"`;

foreach my $k (@getsltid) {
#print $k;
if ($k =~ /\id\b/) {
   my @aslt = split(':', $k);
   my $sltaID =  $aslt[1];
   $sltaID =~ s/,$//;
   $sltaID =~ s/\"//g;
   $sltaID =~ s/^\s+|\s+$//g;
   $sltid = $sltaID;
return $sltid;
last;
}
}

if ( $policy eq "onvault" ) {
my @addPolicyTemplate=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"op":"cloud","name":"$onvaultpolicyname","iscontinuous":false,"starttime":68400,"endtime":67800,"rpo":"$onvaultrpo","rpom":"hours","retention":"14","retentionm":"days","priority":"medium","temp-id":"978","options":[{"name":"immutabilitydays","value":"14","metadata":{"select":false,"constant":false,"max":36525,"apptype":"*","type":"range","multi":false,"default":"0","min":0,"apponly":false,"name":"immutabilitydays","overridable":true,"alias":"Enforced Retention (days)","desc":"If set, it will be impossible to expire images created with this policy or modify their expiration date until this number of days has passed since its creation.  This value must be equal to or less than the regular retention on the policy","range":true,"value":[{"desc":"","value":0,"isSelected":false}],"disabled":false},"optionid":"","dirty":true}],"scheduling":"windowed","scheduletype":"daily","repeatinterval":"1","exclusiontype":"none","exclusioninterval":"1","exclusion":"none","selection":"none","slt":{"id":"$sltid"}}' https://$AGMips/actifio/slt/$sltid/policy 2>/dev/null`;
#print @addPolicyTemplate;
}

my @createprofile=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"name":"$profilename","performancepool":"act_per_pool000","cid":"$applianceid","localnode":"$appliancename"}' https://$AGMips/actifio/slp 2>/dev/null`;
#print @createprofile; 

}

sub protectApp {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

#my $applianceid=getApplianceID();
#print "appliance id is " . $applianceid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}
my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";
print "\n";
if ( $appid eq "" ) {
die "could not get appID \n";
}

my $clusterid;
my @appclustdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application/$appid"`;

foreach my $p (@appclustdetails) {
#print $p . "\n";
if ($p =~ /\bclusterid\b/) {
#print $p . "\n";
my @cluid = split(':', $p);
my $clustid = $cluid[1];
$clustid =~ s/,$//;
$clustid =~ s/\"//g;
$clustid =~ s/^\s+|\s+$//g;
$clusterid=$clustid;
#print "inside cluster id is " . $clusterid . "\n";
last;
}
}

my @sltdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/slt?filter=name:==$templatename&filter=clusterid:==$clusterid"`;

if ( @sltdetails < 4 ) {
print "Template Name: " . $templatename . " not found\n";
}

my $sltf;
my $sltid;
my $slpf;
my $slpid;
my $slpID;

foreach my $i (@sltdetails) {
if ($i =~ /\bid\b/) {
my @sltin = split(':', $i);
my $slti =  $sltin[1];
$slti =~ s/,$//;
$slti =~ s/\"//g;
$slti =~ s/^\s+|\s+$//g;
$sltid = $slti;
#print "sltID:     " . $sltid . "\n";
}
 }

print "sltID:     " . $sltid . "\n";

my @slpdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/slp?filter=name:==$profilename&filter=clusterid:==$clusterid"`;

if ( @slpdetails < 4 ) {
print "Profile Name: " . $profilename . " not found\n";
}

foreach my $i (@slpdetails) {
if ($i =~ /\bid\b/) {
my @slpin = split(':', $i);
my $slpi =  $slpin[1];
$slpi =~ s/,$//;
$slpi =~ s/\"//g;
$slpi =~ s/^\s+|\s+$//g;
$slpid = $slpi;
#print "slpID:     " . $slpid . "\n";
}
 }

print "slpID:     " . $slpid . "\n";

my $policyid;
my $optype;
my @parr;
my $bkp_job_id;
my @policydet=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/slt/$sltid/policy"`;

#print "curl -XGET -k -s --tlsv1.2 -H Authorization: Actifio " . $sessionid . " https://" . $AGMips . "/actifio/slt/" . $sltid . "policy";
print "slt id is " . $sltid . "\n";

if ( @policydet < 4 ) {
print "Policy Details for " . $appname . " not found\n";
}

#foreach my $p (@policydet) {
#if ($p =~ /\@type/) {
#$f = 1;
#}

#if ($f == 1) {
#push(@parr, $p);
#}

#if ($p =~ /\bop\b/) {
#        $f = 0;
#}
#continue;
#last;
#}

foreach my $p (@policydet) {
#print $p;
if ($p =~ /\bid\b/) {
my @poli = split(':', $p);
my $polid =  $poli[1];
$polid =~ s/,$//;
$polid =~ s/\"//g;
$polid =~ s/^\s+|\s+$//g;
$policyid = $polid;
}
#if ($p =~ /\bop\b/) {
#my @opi = split(':', $p);
#my $opt =  $opi[1];
#$opt =~ s/,$//;
#$opt =~ s/\"//g;
#$opt =~ s/^\s+|\s+$//g;
#$optype = $opt;
#}
#print "operation type is " . $optype . "\n";
if ($policyid ne "") {
#print "PolicyID:     " . $policyid . "\n";
last;
}
}

#print $policyid . "\n";

my @protecturl=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"application":{"id":"$appid"},"scheduleoff":"true","slp":{"id":"$slpid"},"slt":{"id":$sltid}}' https://$AGMips/actifio/sla 2>/dev/null`;

#print "curl -XPOST -k --tlsv1.2 -H Authorization: Actifio " . $sessionid . "-H Content-Type: application/json -d '{application:{id:" . $appid . "},scheduleoff:true,slp:{id: " . $slpid . "},slt:{id:" . $sltid . "}}' https://" . $AGMips . "/actifio/sla/" . $policyid . "\n";

my $slaaid;
my @sladet=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/sla?filter=appid:==$appid"`;

foreach my $p (@sladet) {
if ($p =~ /\bid\b/) {
my @slai = split(':', $p);
my $slaid =  $slai[1];
$slaid =~ s/,$//;
$slaid =~ s/\"//g;
$slaid =~ s/^\s+|\s+$//g;
$slaaid = $slaid;
last;
}
}

print "sla id is " . $slaaid . "\n";

if ( $slaaid ne "" ) {
print "Application protected \n";
}
else {
die "Application protection is failed \n";
}

my $backuptype;
#my $hanasystemkey;
my $hanatenantprefix;

if ( ( $backuptype ne "" )  && ( $backuptype eq "CBT" ) ) {
$backuptype="yes";
}
else {
$backuptype="no";
}

my @gettaboption=`curl -XGET -k --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application/$appid/settableoption" 2>/dev/null`;

#print "curl -XGET -k --tlsv1.2 -H Authorization: Actifio " . $sessionid . "https://" . $AGMips . "/actifio/application/" . $appid . "/settableoption \n";

my $taboptionid;
my $taboptionid1;
my $taboptionid2;
my $taboptionid3;
my $taboptionid4;
my $taboptionid5;

if ( @gettaboption < 4 ) {
print "Settings Details for " . $appname . " not found\n";
}

my $opname;

foreach my $p (@gettaboption) {
#print $p;
if ($p =~ /\bid\b/) {
my @ops = split(':', $p);
my $opid =  $ops[1];
$opid =~ s/,$//;
$opid =~ s/\"//g;
$opid =~ s/^\s+|\s+$//g;
$taboptionid = $opid;
}

if ($p =~ /\bname\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$opname = $opt;
}
#print "option name is " . $opname . "\n";
if ($opname eq "uselvmcbt") {
#print "optionID:     " . $taboptionid . "\n";
last;
}
}

print "uselvmcbt option ID is " . $taboptionid . "\n";

if ( $taboptionid eq "" ) {
my @settaburl1=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"name":"uselvmcbt","value":"$backuptype"}' https://$AGMips/actifio/application/$appid/settableoption 2>/dev/null`;
}

if ( $taboptionid ne "" ) {
my @settaburl1=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"value":"$backuptype"}' https://$AGMips/actifio/application/$appid/settableoption/$taboptionid 2>/dev/null`;
}

if ( $vgsnapreservespace ne "" ) {

foreach my $p (@gettaboption) {
#print $p;
if ($p =~ /\bid\b/) {
my @ops = split(':', $p);
my $opid =  $ops[1];
$opid =~ s/,$//;
$opid =~ s/\"//g;
$opid =~ s/^\s+|\s+$//g;
$taboptionid1 = $opid;
}

if ($p =~ /\bname\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$opname = $opt;
}
#print "option name is " . $opname . "\n";
if ($opname eq "vgsnapreservespace") {
#print "optionID:     " . $taboptionid1 . "\n";
last;
}
}

if ( $taboptionid1 eq "" ) {
my @settaburl2=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"name":"vgsnapreservespace","value":"$vgsnapreservespace"}' https://$AGMips/actifio/application/$appid/settableoption 2>/dev/null`;
}
if ( $taboptionid1 ne "" ) {
my @settaburl2=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"value":"$vgsnapreservespace"}' https://$AGMips/actifio/application/$appid/settableoption/$taboptionid1 2>/dev/null`;
}
}

if ( $forcefulldbdump ne "" ) {

foreach my $p (@gettaboption) {
#print $p;
if ($p =~ /\bid\b/) {
my @ops = split(':', $p);
my $opid =  $ops[1];
$opid =~ s/,$//;
$opid =~ s/\"//g;
$opid =~ s/^\s+|\s+$//g;
$taboptionid2 = $opid;
}

if ($p =~ /\bname\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$opname = $opt;
}
#print "option name is " . $opname . "\n";
if ($opname eq "forcefulldbdump") {
print "optionID:     " . $taboptionid2 . "\n";
last;
}
}

if ( $taboptionid2 eq "" ) {
my @settaburl3=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"name":"forcefulldbdump","value":"$forcefulldbdump"}' https://$AGMips/actifio/application/$appid/settableoption 2>/dev/null`;
}

if ( $taboptionid2 ne "" ) {
my @settaburl3=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"value":"$forcefulldbdump"}' https://$AGMips/actifio/application/$appid/settableoption/$taboptionid2 2>/dev/null`;
}
}

foreach my $p (@gettaboption) {
#print $p;
if ($p =~ /\bid\b/) {
my @ops = split(':', $p);
my $opid =  $ops[1];
$opid =~ s/,$//;
$opid =~ s/\"//g;
$opid =~ s/^\s+|\s+$//g;
$taboptionid3 = $opid;
}

if ($p =~ /\bname\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$opname = $opt;
}
#print "option name is " . $opname . "\n";
if ($opname eq "keyname") {
print "optionID:     " . $taboptionid3 . "\n";
last;
}
}
if ( $taboptionid3 eq "" ) {
my @settaburl4=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"name":"keyname","value":"$hanasystemkey"}' https://$AGMips/actifio/application/$appid/settableoption 2>/dev/null`;
}

if ( $taboptionid3 ne "" ) {
my @settaburl4=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"value":"$hanasystemkey"}' https://$AGMips/actifio/application/$appid/settableoption/$taboptionid3 2>/dev/null`;
}

if ( $hanatenantprefix ne "" ) {

foreach my $p (@gettaboption) {
#print $p;
if ($p =~ /\bid\b/) {
my @ops = split(':', $p);
my $opid =  $ops[1];
$opid =~ s/,$//;
$opid =~ s/\"//g;
$opid =~ s/^\s+|\s+$//g;
$taboptionid4 = $opid;
}

if ($p =~ /\bname\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$opname = $opt;
}
#print "option name is " . $opname . "\n";
if ($opname eq "tenantkeyname") {
print "optionID:     " . $taboptionid4 . "\n";
last;
} 
} 

if ( $taboptionid4 eq "" ) {
my @settaburl5=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"name":"tenantkeyname","value":"$hanatenantprefix"}' https://$AGMips/actifio/application/$appid/settableoption 2>/dev/null`;
}
if ( $taboptionid4 ne "" ) {
my @settaburl5=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"value":"$hanatenantprefix"}' https://$AGMips/actifio/application/$appid/settableoption/$taboptionid4 2>/dev/null`;
}

}

if ( $dellog ne "" ) {

foreach my $p (@gettaboption) {
#print $p;
if ($p =~ /\bid\b/) {
my @ops = split(':', $p);
my $opid =  $ops[1];
$opid =~ s/,$//;
$opid =~ s/\"//g;
$opid =~ s/^\s+|\s+$//g;
$taboptionid5 = $opid;
}

if ($p =~ /\bname\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$opname = $opt;
}
#print "option name is " . $opname . "\n";
if ($opname eq "dellog") {
print "optionID:     " . $taboptionid5 . "\n";
last;
}
}

if ( $taboptionid5 eq "" ) {
my @settaburl6=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"name":"dellog","value":"$dellog"}' https://$AGMips/actifio/application/$appid/settableoption 2>/dev/null`;
}

if ( $taboptionid5 ne "" ) {
my @settaburl6=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"value":"$dellog"}' https://$AGMips/actifio/application/$appid/settableoption/$taboptionid5 2>/dev/null`;
}

}

if ( $slaaid ne "" ) {
my @finalprotect=`curl -XPUT -k --tlsv1.2 -H "Authorization: Actifio $sessionid"  -H "Content-Type: application/json" -d '{"application":{"id":"$appid"},"scheduleoff":"false","slp":{"id":"$slpid"},"slt":{"id":$sltid}}' https://$AGMips/actifio/sla/$slaaid 2>/dev/null`;

if (@finalprotect == 0) {
die "Application protection is failed \n";
}
else {
print "Application is protected successfully \n";
}
}
}

sub getLatestMountImage {
  my ($sessionid,$AGMip,$appname,$thostid) = @_;
  my @mntImgs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==mount"`;
#my @mntImgs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostid:==$thostid"`; 
#print "curl -XGET -k -s --tlsv1.2 -H Authorization: Actifio " . $sessionid . "https://". $AGMips. "/actifio/backup?filter=appname:==" . $appname . "&filter=jobclass:==mount \n ";
#print "@mntImgs \n";
my $bkpname;
  foreach my $x (@mntImgs) {
   # print $x;
    if ($x =~ /\bhasmountedmap\b/) {
     # print $x;
    $f = 1;
  }

if ($x =~ /\bcatalogstate\b/) {
      #print $x;
    $f = 0;
  }

  if ($f == 1) {
    push(@arra, $x);
   # continue;
   }
if ($f == 0) {
last;
}
}

foreach my $x (@arra) {
#print $x;
  if ($x =~ /\bname\b/ ) {
      my @bkpnameT=split(':',$x);
      $bkpname=$bkpnameT[1];
      $bkpname=~ s/,$//;
      $bkpname=~ s/\"//g;
      $bkpname=~ s/^\s+|\s+$//g;
   if ($bkpname =~ /Image/) {
   last;
    }
  }
  }
  print "Image name: $bkpname\n";
  return $bkpname;
}

sub getCloneMountImage {
  my ($sessionid,$AGMip,$appname,$tappid,$thostid) = @_;
  my @mntImgs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==mount`;
#my @mntImgs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostid:==$thostid"`;
#print "curl -XGET -k -s --tlsv1.2 -H Authorization: Actifio " . $sessionid . "https://". $AGMips. "/actifio/backup?filter=appname:==" . $appname . "&filter=jobclass:== mount \n";
#print "@mntImgs \n";
print "targt app id is " . $tappid . "\n";
my $bckpname;
my $bkpname;
  foreach my $x (@mntImgs) {
   # print $x;
    if ($x =~ /\bbackupname\b/) {
      #print $x;
      my @bkpnameT=split(':',$x);
      $bkpname=$bkpnameT[1];
      $bkpname=~ s/,$//;
      $bkpname=~ s/\"//g;
      $bkpname=~ s/^\s+|\s+$//g;
      #print " in if image name " . $bkpname . "\n";
 } 
  if ($x =~ /$tappid/) { 
     #print "in side " . $bkpname . "\n";
     $bckpname=$bkpname;
   last;
   }
  }
  print "Image name: $bckpname\n";
  return $bckpname;
}

sub unmountdelete {
  my $sessionid = getSessionID();
  $sessionid =~ s/,$//;
  $sessionid =~ s/\"//g;
  $sessionid =~ s/^\s+|\s+$//g;
  if ( $sessionid eq "" ) { die "Authentication is not established\n"; }
  #print "sessionID: $sessionid \n";

  $hostname=$sourceHost;

my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

if ( $appid eq "" ) {
die "could not get appID \n";
}

my $shostid=getHostID();
 # $hostid=getHostID();
  if ( $shostid eq "" ) {
        die "ERROR: could not get source hostid\n";
  }
 # $shostid=$hostid;
   $hostname=$targetHost;
   my $thostid=getOHostID(); 
  if($thostid eq "") { die "ERROR: failed to get targetHost id\n"; }

  # get Image name which need to cleanup
  my $sappname=$appname;
  $tappname=$taname;
  if ( ( $image eq "" ) && ( $taname eq "" ) ) {
        die "Error: either --imageName OR --targetAppName value must be provided \n";
  }
    $hostname=$targetHost;
    $appname=$tappname;
    $tappid=getAppID();
  print "target App id is " . $tappid . "\n";
  if ( ( $image eq "" ) && ( $taname ne "" ) && ( $tappid eq "" ) ) {
       $bkpname = getLatestMountImage($sessionid,$AGMip,$sappname,$thostid);
    }
   if ( ( $image eq "" ) && ( $taname ne "" ) && ( $tappid ne "" ) ) {
        $bkpname = getCloneMountImage($sessionid,$AGMip,$sappname,$tappid,$thostid); 
    }
  if ($image ne "") {
    $bkpname=$image;
  }

  if ( $bkpname eq "" ) {
        die "ERROR: could not get mounted imagename\n";
  }

  my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/backup?filter=backupname:==$bkpname"`;
  #print "@imgdetails \n";
  foreach my $p (@imgdetails) {
    if ($p =~ /\bid\b/) {
      my @backup = split(':', $p);
      $backupid =  $backup[1];
      $backupid =~ s/,$//;
      $backupid =~ s/\"//g;
      $backupid =~ s/^\s+|\s+$//g;
      #print "Image ID:  " . $backupid . "\n";
      $bkpid = $backupid;
      last;
    }
  }
  print "backup id is " . $bkpid . "\n";
  if($bkpid eq "") { die "ERROR: not able to get mounted image id\n"; }

  my @unmount=`curl -XPOST -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"nowait":"true","delete":"true"}' "https://$AGMip/actifio/backup/$bkpid/unmount" 2>/dev/null`;
 # print "@unmount \n";
sleep (10);
my $jobName;
  if ( @unmount == 0 ) {
    my @unmountJob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/jobstatus?filter=status:==running&filter=appname:==$sappname&filter=jobclass:==unmount-delete"`;
    #print "@unmountJob \n";
    foreach $x (@unmountJob) {
        #print $x;
        if ($x =~ /\bjobname\b/) {
        my @mntj = split(':', $x);
        my $mntjid =  $mntj[1];
        $mntjid =~ s/,$//;
        $mntjid =~ s/\"//g;
        $mntjid =~ s/^\s+|\s+$//g;
        print "first unmount job " . $mntjid . "\n";
        $jobName=$mntjid;
        print "Unmount-delete JobName:     " . $jobName . "\n";
        last;
        }
      }
      print "Unmount-detete Job " . $jobName . " submitted Successfully\n";
    }

  else {
    return -1; 
    die "unMount Job submission failed\n $unmount[2]\n";
  }

if ($statuswait eq "yes" && $jobName ne "" ) {
    $job_status=waitForJob($sessionid,$AGMip,$jobName);
    my @jobStat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/jobstatus?filter=jobname:==$jobName"`;
    #print "@jobStat \n";
    $job_status="";
    foreach my $x (@jobStat) {
      if($x =~ /\bstatus\b/) {
        my @jtt=split(':',"$x");
        $job_status=$jtt[1];
        $job_status=~ s/,$//;
        $job_status=~ s/\"//g;
        $job_status=~ s/^\s+|\s+$//g;
        last;
      }
    }
           # $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            print "Unmountdelete Job " . $jobName . " is " . $job_status . "\n";
           return -1;
           exit 1;
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Unmountdelete Job " . $jobName . " is " . $job_status . "\n";
            return 0;
            exit 0;
        }
        # exit $re_code; 
  }

}

use Time::Local;

sub parsedate {
  my($s) = @_;
  my($year, $month, $day, $hour, $minute, $second);

  if($s =~ m{^\s*(\d{1,4})\W*0*(\d{1,2})\W*0*(\d{1,2})\W*0*
                 (\d{0,2})\W*0*(\d{0,2})\W*0*(\d{0,2})}x) {
    $year = $1;  $month = $2;   $day = $3;
    $hour = $4;  $minute = $5;  $second = $6;
    $year = ($year<100 ? ($year<70 ? 2000+$year : 1900+$year) : $year);
    return timelocal($second,$minute,$hour,$day,$month-1,$year);
  }
  return -1;
}

sub getImageRRbyName {
  my ($sessionid,$AGMips,$bkpname) = @_;
  my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/backup?filter=backupname:==$bkpname"`;
  #print "@imgdetails \n";
  foreach my $x (@imgdetails) {
    if($x =~ /\bendpit\b/) {
      #print $x;
      my @endPitT=split(':',$x);
      $endpit=$endPitT[1];
      $endpit=~ s/,$//;
      $endpit=~ s/\"//g;
      $endpit=~ s/^\s+|\s+$//g;
      use POSIX qw( strftime );
      $epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));
      return "$epit";
    }
  }
}

sub getWorkflowCurrentStatus {
  my ($sessionid,$AGMip,$appid,$wfid) = @_;
  @wfDetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  #print "@wfDetails \n";

  #get workflow current details
  $flag=0; $flagc=0; $flagp=0; $flagn=0; $wfCurrStat="";
  foreach $x (@wfDetails) {
    if($x =~ /\bstatus\b/) { $flag=1;}
    if(($flag eq 1) && ($x =~ /\bcurrent\b/) ) { $flagc=1; $flagp=0; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bprev\b/) ) { $flagc=0; $flagp=1; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bnext\b/) ) { $flagc=0; $flagp=0; $flagn=1; }
    if(($flagc eq 1) && ($flagc eq 1) && ($x =~ /\bstatus\b/)) {
      my @stt=split(':',$x);
      $wfCurrStat=$stt[1];
      $wfCurrStat=~ s/,$//;
      $wfCurrStat=~ s/\"//g;
      $wfCurrStat=~ s/^\s+|\s+$//g;
      #print "Workflow current status: $wfCurrStat";
      last;
    }
  }
  return $wfCurrStat;
}

sub getWorkflowCurrentJob {
  my ($sessionid,$AGMip,$appid,$wfid) = @_;
  @wfDetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  #print "@wfDetails \n";

  #get workflow current details
  $flag=0; $flagc=0; $flagp=0; $flagn=0; $wfJobTag="";
  foreach $x (@wfDetails) {
    if($x =~ /\bstatus\b/) { $flag=1;}
    if(($flag eq 1) && ($x =~ /\bcurrent\b/) ) { $flagc=1; $flagp=0; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bprev\b/) ) { $flagc=0; $flagp=1; $flagn=0; }
    if(($flag eq 1) && ($x =~ /\bnext\b/) ) { $flagc=0; $flagp=0; $flagn=1; }
    if(($flagc eq 1) && ($flagc eq 1) && ($x =~ /\bjobtag\b/)) {
      my @jtt=split(':',$x);
      $wfJobTag=$jtt[1];
      $wfJobTag=~ s/,$//;
      $wfJobTag=~ s/\"//g;
      $wfJobTag=~ s/^\s+|\s+$//g;
      #print "Workflow current jobtag: $wfJobTag\n";
      last;
    }
  }

  my @jobs=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/jobstatus?filter=jobtag:==$wfJobTag&filter=status:=="running"`;
  #print "@jobs \n";
  foreach $x (@jobs) {
    if( $x =~ /\bjobname\b/ )  {
      my @pl=split(':',$x);
      $runningJob=$pl[1];
      $runningJob=~ s/,$//;
      $runningJob=~ s/\"//g;
      $runningJob=~ s/^\s+|\s+$//g;
      #print "Workflow current running job: $runningJob \n";
      last;
    }
  }
  return $runningJob;
}

sub waitForJob {
  my ($sessionid,$AGMip,$jobName) = @_;
  do{
    my @jobStat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/jobstatus?filter=jobname:==$jobName"`;
    #print "@jobStat \n";
    $job_status="";
    foreach my $x (@jobStat) {
      if($x =~ /\bstatus\b/) {
        my @jtt=split(':',"$x");
        $job_status=$jtt[1];
        $job_status=~ s/,$//;
        $job_status=~ s/\"//g;
        $job_status=~ s/^\s+|\s+$//g;
        last;
      }
    }

    if ($job_status eq "running") {
        print "$jobName running...\n"; 
        sleep(60);
    }

  } 
  while( ($job_status eq "running") || ($job_status eq "waiting") );
  print $jobName . " - " . $job_status . "\n";
  return $job_status;
}

sub runwf {
  #get sessionID
  my $sessionid = getSessionID();
  $sessionid =~ s/,$//;
  $sessionid =~ s/\"//g;
  $sessionid =~ s/^\s+|\s+$//g;
  if ( $sessionid eq "" ) { die "Authentication is not established\n"; }

  $appname=$dbname;
  $hostid=getHostID();
  if($hostid eq "") { die "ERROR: not able to get hostid for host $hostname \n"; }

  #get app id
  $appid=getAppID();
  $appid=~ s/,$//;
  $appid=~ s/\"//g;
  $appid=~ s/^\s+|\s+$//g;
  if($appid eq "") { die "ERROR: not able to get appid for app $appname \n"; }
  print "Application id: $appid \n";

  # get backup image name
  if($image eq "") {
    $bkpname = getLatestImage();
  }
  else {
    $bkpname = $image;
  }
  if($bkpname eq "") { die "ERROR: not able to get backup image \n"; }
    $pointInTime=getImageRRbyName($sessionid,$AGMip,$bkpname);

  # get backup image srcid
  my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=backupname:==$bkpname"`;
  #print "@imgdetails \n";
  foreach my $p (@imgdetails) {
    if ($p =~ /\bsrcid\b/) {
      my @backup = split(':', $p);
      $backupid =  $backup[1];
      $backupid =~ s/,$//;
      $backupid =~ s/\"//g;
      $backupid =~ s/^\s+|\s+$//g;
      #print "Image ID:  " . $backupid . "\n";
      $bkpSrcID = $backupid;
      last;
    }
  }
  print "backup srcid is " . $bkpSrcID . "\n";

  # get workflow id
  my @wfURL=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/workflow?filter=name:==$wfname&filter=appname:==$appname"`;
  #print "@wfURL \n";
  foreach my $x (@wfURL) {
    if($x =~ /\bcount\b/) {
      my @cntT=split(':',$x);
      $cnt=$cntT[1];
      $cnt=~ s/,$//;
      $cnt=~ s/\"//g;
      $cnt=~ s/^\s+|\s+$//g;
      last;
    }
  }
  if($cnt eq 0 ) { die "ERROR: no workflow found with the name: $wfname \n"; }

  #get workflow id
  foreach my $x (@wfURL) {
    if($x =~ /\bid\b/) {
      my @idT=split(':',$x);
      $wfid=$idT[1];
      $wfid=~ s/,$//;
      $wfid=~ s/\"//g;
      $wfid=~ s/^\s+|\s+$//g;
      last;
    }
  }
  print "Workflow id: $wfid \n";

  my @wfDetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  #print "@wfDetails \n";

  # get schedule details
  $flag=0; $scheduleDetails="";
  foreach my $x (@wfDetails) {
    if($x =~ /\bschedule\b/) { $flag=1;}
    if($flag eq 1) { $scheduleDetails=$scheduleDetails.$x;  }
    if($flag eq 1 && $x =~ "}") { last; }
  }
  $scheduleDetails=~ s/\s+|\s$//g;
  $scheduleDetails=substr $scheduleDetails,0,length($scheduleDetails)-1;
  #print "$scheduleDetails \n";

  # get workflow props
  $flag=0; $wfProps="";
  foreach my $x (@wfDetails) {
    if( $x =~ /\bprops\b/ )  { $flag=1; }
    if ($x =~ /\bitems\b/) { last; }
    if($flag eq 1) { $wfProps = $wfProps . $x; }
  }
  $wfProps=~ s/\s+|\s$//g;                            # remove blank spaces
  $wfProps=substr $wfProps,0,length($wfProps)-1;      # remove , at the end
  # specify backup image in $wfProps
  $wfProps=(substr $wfProps,0,length($wfProps)-1).',{"key":"image","value":"'.$bkpSrcID.'"}'.']';
  #print "$wfProps \n";

  # get workflow items
  $flag=0; $wfItems="";
  foreach my $x (@wfDetails) {
    if( $x =~ /\bitems\b/ )  { $flag=1; }
    if ($x =~ /\bdisabled\b/) { last; }
    if($flag eq 1) { $wfItems = $wfItems . $x; }
  }
  $wfItems=~ s/\s+|\s$//g;                            # remove blank spaces
  $wfItems=substr $wfItems,0,length($wfItems)-1;      # remove , at the end

  #if workflow is for reprovision
  if($reprov eq "yes") {
    $repAppID=""; $repAppName="";

    #get reprovision app name
    $flag=0; $idln=0; $ln=0;
    foreach $x (@wfDetails) {
      $ln=$ln+1;
      if( $x =~ /\bitems\b/ )  {  $flag = 1; }
      if( $flag eq 1 && $x =~ /\bitems\b/) { $flag=2; }
      if($flag eq 2 && $x =~ /\bdbsid\b/) { $idln=$ln; }
      if( ($x =~ /\bvalue\b/) && ($ln eq ($idln+1)) ) {
            print $x;
            my @rpt=split(':',$x);
            $repAppName=$rpt[1];
            $repAppName=~ s/,$//;
            $repAppName=~ s/\"//g;
            $repAppName=~ s/^\s+|\s+$//g;
            last;
           print " re app name is " . $repAppName . "\n";  
      }
    }
    if($repAppName eq "") { die "ERROR: there are no existing apps to reprovision \n"; }

    my @repAppDet=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" https://$AGMip/actifio/application?filter=appname:==$repAppName`;
    #print "@repAppDet \n";
    foreach $x (@repAppDet) {
      if($x =~ /\bid\b/) {
        my @idt=split(':',$x);
        $repAppID=$idt[1];
        $repAppID=~ s/,$//;
        $repAppID=~ s/\"//g;
        $repAppID=~ s/^\s+|\s+$//g;
        last;
      }
    }
    if($repAppID eq "") { die "ERROR: not able to get reprovision app - $repAppName - id \n"; }

    $wfItems= (substr $wfItems,0,length($wfItems)-3) . ',{"name":"reprovision","items":[{"name":"app","value":"'.$repAppID.'"}]}' . ']}]';
  }
  #print "$wfItems \n";

  my @runWf;
  if($subtype eq "directmount") {
    @runWf=`curl -XPOST -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{
        "operation":"run",
        "update": { "id": "$wfid", "name": "", $scheduleDetails, $wfProps, $wfItems }
      }' https://$AGMip/actifio/application/$appid/workflow/$wfid`;
  }
  #print "@runWf \n";

  if(@runWf == 0) {
    print "Workflow submitted successfully\n";
    sleep(15);
    $wfCurrStat=getWorkflowCurrentStatus($sessionid,$AGMip,$appid,$wfid);
    print "Workflow current status: $wfCurrStat \n";
    if($wfCurrStat eq "RUNNING") {
      $wfJob=getWorkflowCurrentJob($sessionid,$AGMip,$appid,$wfid);
      print "Workflow current job is: $wfJob \n";
    }
  }
  else {
    print "failed to submit workflow. \n $runWf[2]\n";
    return -1;
    exit 1;
  }
  if ( ($statuswait eq "yes") && ($wfCurrStat eq "RUNNING") ) {
    while ($wfCurrStat eq "RUNNING") {
      $wfJob=getWorkflowCurrentJob($sessionid,$AGMip,$appid,$wfid);
      waitForJob($sessionid,$AGMip,$wfJob);
      sleep(10);
      $wfCurrStat=getWorkflowCurrentStatus($sessionid,$AGMip,$appid,$wfid);
      $job_status=$wfCurrStat;
     }    
   }
    
if  ($statuswait eq "yes") { 
my @jobStat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMip/actifio/jobstatus?filter=jobname:==$wfJob"`;
    #print "@jobStat \n";
    $job_status="";
    foreach my $x (@jobStat) {
      if($x =~ /\bstatus\b/) {
        my @jtt=split(':',"$x");
        $job_status=$jtt[1];
        $job_status=~ s/,$//;
        $job_status=~ s/\"//g;
        $job_status=~ s/^\s+|\s+$//g;
        last;
      }
    }
    #  $wfCurrStat=waitForJob($sessionid,$AGMip,$wfJob);
     # $job_status=$wfCurrStat;
              # $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            #print "re code is " . $re_code . "\n"; 
            print $job_errmsg . "\n";
            print "Workflow Job " . $wfJob . " is " . $job_status . "\n";
           return -1;
           exit 1;
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Workflow Job " . $wfJob . " is " . $job_status . "\n";
            return 0;
            exit 0;
        }
         #exit $re_code;
}

}

