#!/bin/bash
SYBASE_CONFIG_FILE="/act/scripts/act_Sybase_Src.conf"
MAXDB_CONFIG_FILE="/act/scripts/act_MaxDB_src.conf"
IQSYBASE_CONFIG_FILE="/act/scripts/act_SybaseIQ_Src.conf"
if [ -f "$SYBASE_CONFIG_FILE" ]; then
  echo -e "Invoke Sybase validateVdisk"
  source /act/act_scripts/sybase/dump/validateVdisk.sh
elif  [ -f "$MAXDB_CONFIG_FILE" ]; then
  echo -e "Invoke Maxdb validateVdisk"
  source /act/act_scripts/maxdb/dump/validateVdisk.sh
elif [ -f "$IQSYBASE_CONFIG_FILE" ]; then
  echo -e "Invoke sybaseIQ validateVdisk"
  source /act/act_scripts/sybaseiq/dump/validateVdisk.sh
else
  echo "Error!!!! Not Supported DB..Exiting!!!"
  exit 1
fi
